#!/usr/bin/perl

use strict;
use POSIX();
use Cwd qw(); 
use warnings;
#use diagnostics;
#use Math::Matrix;
use Storable qw(dclone);
use Time::HiRes qw(time);
use Term::ANSIColor qw(:constants);

my $the_cut = 3;
my $the_pre = 0;
my $act_fun = "";
my $the_verb = 0;
my $acc_tech = 0;
my $dv_file = "";
my $the_test = 0;
my $the_tech = 1;
my $quan_bit = 8;
my $in_width = 8;
my $the_wout = 0;
my $out_width = 8;
my $val_file = "";
my $the_rep = "csd";
my $act_fun_cnt = 1;
my @act_fun_arr = ();
my $the_aim = "area";
my $file_weight = "";
my $test_num = 10000;
my $the_lib = "tsmc40";
my $tune_cpu_lim = 1800;

my $arg_ok = 1;
my $arg_cnt = 0;
while (1){
  if (defined $ARGV[$arg_cnt]){
    if ($ARGV[$arg_cnt] eq "-h" or $ARGV[$arg_cnt] eq "-help"){
      $arg_ok = 0;
      last;
    }
    else{
      if (index($ARGV[$arg_cnt], "-quan=") != -1){
        $quan_bit = substr($ARGV[$arg_cnt], 6, length($ARGV[$arg_cnt])-6) + 0.0;
        if ($quan_bit < 1){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-ibw=") != -1){
        $in_width = substr($ARGV[$arg_cnt], 5, length($ARGV[$arg_cnt])-5) + 0.0;
        if ($in_width < 1){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-obw=") != -1){
        $out_width = substr($ARGV[$arg_cnt], 5, length($ARGV[$arg_cnt])-5) + 0.0;
        if ($out_width < 1){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-not=") != -1){
        $test_num = substr($ARGV[$arg_cnt], 5, length($ARGV[$arg_cnt])-5) + 0.0;
        if ($test_num < 1){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-wout") != -1){
        $the_wout = 1;
      }
      elsif (index($ARGV[$arg_cnt], "-verb") != -1){
        $the_verb = 1;
      }
      elsif (index($ARGV[$arg_cnt], "-pre") != -1){
        $the_pre = 1;
      }
      elsif (index($ARGV[$arg_cnt], "-tcl=") != -1){
        $tune_cpu_lim = substr($ARGV[$arg_cnt], 5, length($ARGV[$arg_cnt])-5) + 0.0;
        if ($tune_cpu_lim <= 0){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-tech=") != -1){
        $the_tech = substr($ARGV[$arg_cnt], 6, length($ARGV[$arg_cnt])-6) + 0.0;
        if ($the_tech < 0 and $the_tech > 4){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-act=") != -1){
        $act_fun = substr($ARGV[$arg_cnt], 5, length($ARGV[$arg_cnt])-5);
        #print "act_fun: $act_fun \n";

        my $init_index = 0;
        my $last_index;
        my $the_func;
        while (1){
          $last_index = index($act_fun, "/", $init_index);

          if ($last_index == -1){
            $the_func = substr($act_fun, $init_index, length($act_fun)-$init_index);
            #print "the_func: $the_func \n";
            #sleep 1;

            if ($the_func eq "lin" or $the_func eq "relu" or $the_func eq "satlin" or $the_func eq "satlins"){ 
              $act_fun_cnt++;
              $act_fun_arr[$act_fun_cnt] = $the_func;
              last;
            }
            else{
              $arg_ok = 0;
              last;
            }
          }
          else{
            $the_func = substr($act_fun, $init_index, $last_index-$init_index);
            #print "the_func: $the_func \n";
            #sleep 1;

            if ($the_func eq "lin" or $the_func eq "relu" or $the_func eq "satlin" or $the_func eq "satlins"){ 
              $act_fun_cnt++;
              $act_fun_arr[$act_fun_cnt] = $the_func;

              $init_index = $last_index+1;
            }
            else{
              $arg_ok = 0;
              last;
            }
          }
        }
      }
      elsif (index($ARGV[$arg_cnt], "-test=") != -1){
        $the_test = substr($ARGV[$arg_cnt], 6, length($ARGV[$arg_cnt])-6) + 0.0;
        if ($the_test != 0 and $the_test != 1){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-dvf=") != -1){
        $dv_file = substr($ARGV[$arg_cnt], 5, length($ARGV[$arg_cnt])-5);
        if ($dv_file eq ""){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-vf=") != -1){
        $val_file = substr($ARGV[$arg_cnt], 4, length($ARGV[$arg_cnt])-4);
        if ($val_file eq ""){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-acc=") != -1){
        $acc_tech = substr($ARGV[$arg_cnt], 5, length($ARGV[$arg_cnt])-5) + 0.0;
        if ($acc_tech != 0 and $acc_tech != 1){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-lib=") != -1){
        $the_lib = substr($ARGV[$arg_cnt], 5, length($ARGV[$arg_cnt])-5);
        if ($the_lib ne "tsmc40" and $the_lib ne "tsmc180" and $the_lib ne "xfab"){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-rep=") != -1){
        $the_rep = substr($ARGV[$arg_cnt], 5, length($ARGV[$arg_cnt])-5);
        if ($the_rep ne "binary" and $the_rep ne "csd"){
          $arg_ok = 0;
        }
      }
      elsif (index($ARGV[$arg_cnt], "-aim=") != -1){
        $the_aim = substr($ARGV[$arg_cnt], 5, length($ARGV[$arg_cnt])-5);
        if ($the_aim ne "area" and $the_aim ne "delay"){
          $arg_ok = 0;
        }
      }
      else{
        if (!$arg_cnt){
          $file_weight = $ARGV[0];
        }
        else{
          $arg_ok = 0;
          last;
        }
      }
    }
  }
  else{
    if (!$arg_cnt){
      $arg_ok = 0;
    }
    last;
  }

  $arg_cnt++;
}

if ($arg_ok){
  if ($file_weight ne "" and ($the_test == 0 or $dv_file ne "") and (!$the_pre or $val_file ne "" or $acc_tech)){
    main_part();
  }
  else{
    help_part();
  }
}
else{
  help_part();
}

sub help_part{
  print "########################################################################################################################################################################################################## \n";
  print "# Usage:       perl ann2ver.pl <File_Name> -ibw=<int> -obw=<int> -quan=<int> -tech=0/1/2/3/4 -act=lin/relu/satlin/satlins -test=0/1 -not=<int> -dvf=<File_Name> -acc=0/1 -pre -tcl=<int> -vf=<Fine_Name> # \n";
  print "#                              -rep=binary/csd -aim=area/delay -lib=tsmc40/tsmc180/xfab -wout -h                                                                                                         # \n";
  print "# File_Name:   Name of the file including the ANN weigths                                                                                                                                                # \n";
  print "# -ibw:        Bitwidth of inputs, by default it is 8                                                                                                                                                    # \n";
  print "# -obw:        Bitwidth of outputs, by default it is 8                                                                                                                                                   # \n";
  print "# -quan:       Quantization value for weights, by default it is 8                                                                                                                                        # \n";
  print "# -tech:       Technique to design the ANN, by default it is 1                                                                                                                                           # \n";
  print "#                 0: Weights are defined as inputs (iw)                                                                                                                                                  # \n";
  print "#                 1: Weights are defined as constant values (cw)                                                                                                                                         # \n";
  print "#                 2: Multiplication of weights by inputs and their additions are realized under the shift-adds architecture using multiple constant multiplciation blocks (mcm)                          # \n";
  print "#                 3: Multiplication of weights by inputs and their additions are realized under the shift-adds architecture using constant array vector multiplication blocks (cavm)                     # \n";
  print "#                 4: Multiplication of weights by inputs and their additions are realized under the shift-adds architecture using constant matrix vector multiplication blocks (cmvm)                    # \n";
  print "# -act:        Activation function of neurons on each layer separated by a slash, by default it is satlins at the hidden layers and lin at the output layer                                              # \n";
  print "#                 0: lin  - linear                                                                                                                                                                       # \n";
  print "#                 1: relu - rectified linear unit                                                                                                                                                        # \n";
  print "#                 2: satlin  - saturating linear transfer function, a.k.a. linearized sigmoid fuction                                                                                                    # \n";
  print "#                 3: satlins - symmetric saturating linear transfer function, a.k.a hard hyperbolic tangent                                                                                              # \n";
  print "# -test:       Technique to verify the ANN design, by default it is 0                                                                                                                                    # \n";
  print "#                 0: Random                                                                                                                                                                              # \n";
  print "#                 1: Directed (using the test data)                                                                                                                                                      # \n";
  print "# -not:        Number of test patterns to be used in the random verification technique, by default it is 10000                                                                                           # \n";
  print "# -dvf:        Name of the file including the test values to be used in the directed verification technique                                                                                              # \n";
  print "# -pre:        Pre-processing phase for determining the ANN design parameters, by default there is no such phase. Needs the validation data set and the technique used to compute the accuracy           # \n";
  print "#                 Finding the minimum quantization value which leads to the maximum accuracy                                                                                                             # \n";
  print "#                 Tuning the integer weights such that the ANN design area is reduced and the accuracy of the ANN design is improved/kept the same                                                       # \n";
  print "# -tcl:        CPU time limit for tuning the integer weights, by default it is 1800 seconds                                                                                                              # \n";
  print "# -vf:         Name of the file including the validation values to be used in the preprocessing                                                                                                          # \n";
  print "# -acc:        Computes the accuracy of the ANN design with respect to the expected values used in the directed verification technique, by default it does not                                           # \n";
  print "#                 1: Classification (while only one output has 1 value the others have the zero value)                                                                                                   # \n";
  print "# -rep:        Number representation used in the CMVM algorithm, by default it is CSD                                                                                                                    # \n";
  print "# -aim:        Optimization aim in the MCM, CAVM, and CMVM algorithm, by default it is area                                                                                                              # \n";
  print "# -lib:        Gate library to be used in synthesis, by default it is tsmc40                                                                                                                             # \n";
  print "# -wout:       Quantized weight and bias values in each layer are written into related files, by default they are not                                                                                    # \n";
  print "# -h:          Prints this screen                                                                                                                                                                        # \n";
  print "# Description: Automatically generates the Verilog code of the ANN design                                                                                                                                # \n";
  print "########################################################################################################################################################################################################## \n";
}

sub skip_spaces_forward{
  my ($the_string, $the_offset) = @_;
  my $the_length = length($the_string);

  while (index($the_string, " ", $the_offset) eq $the_offset) {
    $the_offset++;
    if ($the_offset > $the_length) {
      last;
    }
  }

  return $the_offset;
}

sub skip_spaces_backward{
  my ($the_string, $the_offset) = @_;

  while (index($the_string, " ", $the_offset) eq $the_offset) {
    $the_offset--;
    if ($the_offset < 0) {
      last;
    }
  }

  return $the_offset;
}

sub is_inside_numeric_array{
  my ($the_element, $the_cnt, @the_arr) = @_;

  my $the_result = 0;

  foreach my $i (1 .. $the_cnt){
    if ($the_arr[$i] == $the_element){
      $the_result = $i;
      last;
    }
  }

  return $the_result;
}

sub int2sign{
  my ($the_int, $the_len) = @_;
  #print "the_int: $the_int ";

  my @the_rep = ();

  if ($the_int < 0){
    $the_int = 2**$the_len - abs($the_int);
  }
  #print "act_int: $the_int the_rep: ";

  foreach my $i (1 .. $the_len){
    $the_rep[$i] = 0;
  }

  my $the_index = 0;
  while ($the_int > 1){
    $the_index++;
    my $the_val = $the_int % 2;
    $the_rep[$the_index] = $the_val;
    $the_int = ($the_int - $the_val) / 2;
  }

  $the_index++;
  $the_rep[$the_index] = $the_int;

  #foreach my $i (1 .. $the_len){
  #  print "$the_rep[$i]";
  #}
  #print "\n";
  #sleep 1;

  return (@the_rep);
}

sub int2bin{
  my ($the_int, $the_len) = @_;

  my @the_rep = ();

  foreach my $i (1 .. $the_len){
    $the_rep[$i] = 0;
  }

  my $the_index = 0;
  while ($the_int > 1){
    $the_index++;
    my $the_val = $the_int % 2;
    $the_rep[$the_index] = $the_val;
    $the_int = ($the_int - $the_val) / 2;
  }

  $the_index++;
  $the_rep[$the_index] = $the_int;

  return (@the_rep);
}

sub bin2csd {
  my ($bin_len, @bin_rep) = @_;

  my @csd_rep = ();
  my $csd_len = $bin_len;

  $csd_len++;
  $bin_rep[$csd_len] = 0;
  $csd_len++;
  $bin_rep[$csd_len] = 0;
  $csd_len--;

  my $the_state = 0;
  foreach my $i (1 .. $bin_len+1){
    #print "[INFO]: $the_state, $bin_rep[$i+1], $bin_rep[$i] \n";
    if ($the_state == 0 and $bin_rep[$i+1] == 0 and $bin_rep[$i] == 0){
      $csd_rep[$i] = 0;
      $the_state = 0;
    }
    elsif ($the_state == 0 and $bin_rep[$i+1] == 0 and $bin_rep[$i] == 1){
      $csd_rep[$i] = 1;
      $the_state = 0;
    }
    elsif ($the_state == 0 and $bin_rep[$i+1] == 1 and $bin_rep[$i] == 0){
      $csd_rep[$i] = 0;
      $the_state = 0;
    }
    elsif ($the_state == 0 and $bin_rep[$i+1] == 1 and $bin_rep[$i] == 1){
      $csd_rep[$i] = -1;
      $the_state = 1;
    }
    elsif ($the_state == 1 and $bin_rep[$i+1] == 0 and $bin_rep[$i] == 0){
      $csd_rep[$i] = 1;
      $the_state = 0;
    }
    elsif ($the_state == 1 and $bin_rep[$i+1] == 0 and $bin_rep[$i] == 1){
      $csd_rep[$i] = 0;
      $the_state = 1;
    }
    elsif ($the_state == 1 and $bin_rep[$i+1] == 1 and $bin_rep[$i] == 0){
      $csd_rep[$i] = -1;
      $the_state = 1;
    }
    elsif ($the_state == 1 and $bin_rep[$i+1] == 1 and $bin_rep[$i] == 1){
      $csd_rep[$i] = 0;
      $the_state = 1;
    }
  }

  return ($csd_len, @csd_rep);
}

sub find_nonzero_digits_csd{
  my ($the_num) = @_;

  my $nzd_cnt = 0;
  my @nzd_arr = ();
  
  if ($the_num){
    my $the_sign = 0;
    if ($the_num < 0){
      $the_sign = 1;
      $the_num = (-1)*$the_num;
    }

    my $the_width = int(log($the_num)/log(2))+1;
    my (@bin_rep) = int2bin($the_num, $the_width);
    my ($csd_len, @csd_rep) = bin2csd($the_width, @bin_rep);
    foreach my $i (1 .. $csd_len){
      if ($csd_rep[$i]){
        $nzd_cnt++;
        $nzd_arr[$nzd_cnt] = (-1)**$the_sign * $csd_rep[$i] * 2**($i-1);
      }
    }
  }

  return ($nzd_cnt, @nzd_arr);
}

sub extract_paths{
  my ($paths_file) = @_;

  my $paths_ok = 1;
  my $path_algo = " ";
  my $path_high2low = " ";

  if (-e $paths_file){
    my $the_index = 0;
    my $init_index = 0;
    my $last_index = 0;

    if (open (my $file_header, '<:encoding(UTF-8)', $paths_file)){
      while (my $the_line = <$file_header>){
        chomp $the_line;
        #print "$the_line \n";

        $the_index = index ($the_line, "=");

        if ($the_index >= 0){
          $init_index = skip_spaces_forward($the_line, 0);
          $last_index = skip_spaces_backward($the_line, $the_index-1);
          my $the_solver = substr($the_line, $init_index, $last_index-$init_index+1);
          #print "the_solver: $the_solver \n";

          $init_index = skip_spaces_forward($the_line, $the_index+1);
          $last_index = skip_spaces_backward($the_line, length($the_line));
          my $the_path = substr($the_line, $init_index, $last_index-$init_index+1);
          #print "the_path: $the_path \n";

          if ($the_path =~ /[0-9a-zA-Z_]/ ){
            if ($the_tech == 2 and  $the_solver eq "mcm_algo"){
              $path_algo = $the_path;
            }
            elsif ($the_tech == 2 and $the_solver eq "mcm_high2low"){
              $path_high2low = $the_path;
            }
            elsif ($the_tech == 3 and  $the_solver eq "cavm_algo"){
              $path_algo = $the_path;
            }
            elsif ($the_tech == 3 and $the_solver eq "cavm_high2low"){
              $path_high2low = $the_path;
            }
            elsif ($the_tech == 4 and $the_aim eq "area" and $the_solver eq "cmvm_algo"){
              $path_algo = $the_path;
            }
            elsif ($the_tech == 4 and $the_aim eq "delay" and $the_solver eq "cmvm_dc_algo"){
              $path_algo = $the_path;
            }
            elsif ($the_tech == 4 and $the_solver eq "cmvm_high2low"){
              $path_high2low = $the_path;
            }
          }
          else{
            $paths_ok = 0;
          }
        }
      }

      if ($path_algo eq " "){
        $paths_ok = 0;
        print RED, "[ERROR] The path to the shift-adds algorithm could not be extracted from the $paths_file file! \n", RESET;
      }
      if ($path_high2low eq " "){
        $paths_ok = 0;
        print RED, "[ERROR] The path to the high2low algorithm could not be extracted from the $paths_file file! \n", RESET;
      }

      close ($file_header);
    }
    else{
      print RED, "[ERROR] Could not open the $paths_file file! \n", RESET;
    }
  }
  else{
    print RED, "[ERROR] Could not find the $paths_file file including paths to solvers! \n", RESET;
  }

  return ($paths_ok, $path_algo, $path_high2low);
}

sub file_read_weights{
  my $layer_cnt = 0;
  my @layer_arr = ();
  my @weight_mat = ();
  my @weight_flt_mat = ();

  my $init_index = 0;
  my $last_index = 0;

  my @qw_arr = ();
  my $max_bit = 0;
  my $nzd_cost = 0;
  my $weight_num = 0;

  if (open (my $fid_weight, '<:encoding(UTF-8)', $file_weight)){
    my $the_line = <$fid_weight>;
    my $length_line = length($the_line);
    chomp $the_line;
    #print "[INFO] The line: $the_line \n";
    #sleep 1;

    $init_index = index($the_line, "[");
    if ($init_index != -1){
      $init_index++;

      my $the_end = 0;
      while (!$the_end){
        $last_index = $init_index;
        while (substr($the_line, $last_index, 1) ne " " and substr($the_line, $last_index, 1) ne "]"){
          $last_index++;

          if ($last_index > $length_line){
            $the_end = 1;
            last;
          }
        }

        my $the_val = substr($the_line, $init_index, $last_index-$init_index) + 0.0;
        #print "the_val: $the_val \n";
        #sleep 1;

        $layer_cnt++;
        $layer_arr[$layer_cnt] = $the_val;

        if (substr($the_line, $last_index, 1) eq "]"){
          $the_end = 1;
        }
        else{
          $init_index = skip_spaces_forward($the_line, $last_index);
        }
      }

      my $in_cnt = 0;
      my $out_cnt = 0;
      my $layer_num = 0;
      while ($the_line = <$fid_weight>){
        chomp ($the_line);
        my $length_line = length($the_line);
        #print "the_line: $the_line \n";
        #sleep 1;

        if (index($the_line, "Hidden Layer ") != -1){
          $layer_num++;
          $out_cnt = 0;
          $in_cnt = 0;
        }
        else{
          $out_cnt++;
          $in_cnt = 0;

          $init_index = skip_spaces_forward($the_line, 0);
          if ($init_index < $length_line){
            $the_end = 0;
            while (!$the_end){
              $last_index = $init_index;

              while (substr($the_line, $last_index, 1) ne " "){
                $last_index++;

                if ($last_index > $length_line){
                  $the_end = 1;
                  last;
                }
              }

              my $the_val = substr ($the_line, $init_index, $last_index-$init_index) + 0.0;
              #print "the_val: $the_val \n";
              #sleep 1;

              $in_cnt++;
              $weight_flt_mat[$layer_num][$out_cnt][$in_cnt] = $the_val;
              my $quan_val = POSIX::ceil((2**$quan_bit)*$the_val);
              $weight_mat[$layer_num][$out_cnt][$in_cnt] = $quan_val;

              #compute cost
              my ($nzd_cnt, @csd_rep) = find_nonzero_digits_csd($quan_val);
              $nzd_cost += $nzd_cnt;

              $weight_num++;
              if ($quan_val){
                my $quan_val_bit = POSIX::ceil(log(abs($quan_val))/log(2));
                if (defined $qw_arr[$quan_val_bit]){
                  $qw_arr[$quan_val_bit]++;
                }
                else{
                  $qw_arr[$quan_val_bit] = 1;
                }

                if ($quan_val_bit > $max_bit){
                  $max_bit = $quan_val_bit;
                }
              }
              else{
                if (defined $qw_arr[1]){
                  $qw_arr[1]++;
                }
                else{
                  $qw_arr[1] = 1;
                }
              }

              if (!$the_end){
                $init_index = skip_spaces_forward($the_line, $last_index);

                if ($init_index >= $length_line){
                  $the_end = 1;
                }
              }
            }
          }
        }
      }
    }
    else{
      print "[ERROR] The layer definitions should have started with left square bracket on the first line\n";
    }

    close ($fid_weight);
  }
  else{
    print "[ERROR] Could not open the $file_weight file \n";
  }

  my $the_per = 0;
  print "[INFO] Number of Weights: $weight_num \n";
  print "[INFO] Weight Analysis when Quantization Value is $quan_bit \n";
  foreach my $i (1 .. $max_bit){
    if (defined $qw_arr[$i]){
      $the_per = int (100*($qw_arr[$i]/$weight_num));
      print "[INFO] Number of weights with $i bits: $qw_arr[$i] ($the_per%) \n";
    }
  }
  print "\n";

  return ($layer_cnt, $nzd_cost, \@layer_arr, \@weight_mat, \@weight_flt_mat);
}

sub write_module_io_wei{
  my ($fid_ver, $module_name, $pi_cnt, $po_cnt, $pi_size, $po_size, $layer_cnt, $layer_arr_ref, $wo_size_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @wo_size = @ {$wo_size_ref};
  
  printf $fid_ver "module %0s (", $module_name;
  foreach my $i (1 .. $pi_cnt){
    printf $fid_ver "in%0d, ", $i;
  }
  foreach my $i (2 .. $layer_cnt){
    foreach my $j (1 .. $layer_arr[$i]){
      printf $fid_ver "w%0d_%0d, ", $i, $j;
    }
  }
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_ver "out%0d, ", $i;
  }
  printf $fid_ver "out%0d); \n", $po_cnt;

  printf $fid_ver "\n";
  
  printf $fid_ver "input signed [%0d:0] ", $pi_size-1; 
  foreach my $i (1 .. $pi_cnt-1){
    printf $fid_ver "in%0d, ", $i;
  }
  printf $fid_ver "in%0d; \n", $pi_cnt;

  foreach my $i (2 .. $layer_cnt){
    printf $fid_ver "input signed [%0d:0] ", $wo_size[$i]-1; 
    foreach my $j (1 .. $layer_arr[$i]-1){
      printf $fid_ver "w%0d_%0d, ", $i, $j;
    }
    printf $fid_ver "w%0d_%0d; \n", $i, $layer_arr[$i];
  }

  printf $fid_ver "output signed [%0d:0] ", $po_size-1; 
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_ver "out%0d, ", $i;
  }
  printf $fid_ver "out%0d; \n", $po_cnt;

  printf $fid_ver "\n";
}

sub write_layer_module_io_wei{
  my ($fid_ver, $module_name, $pi_cnt, $po_cnt, $pi_size, $po_size, $wo_size) = @_;
  
  printf $fid_ver "module %0s (", $module_name;
  foreach my $i (1 .. $pi_cnt){
    printf $fid_ver "in%0d, ", $i;
  }
  foreach my $i (1 .. $po_cnt){
    printf $fid_ver "w%0d, ", $i;
  }
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_ver "out%0d, ", $i;
  }
  printf $fid_ver "out%0d); \n", $po_cnt;

  printf $fid_ver "\n";
  
  printf $fid_ver "input signed [%0d:0] ", $pi_size-1; 
  foreach my $i (1 .. $pi_cnt-1){
    printf $fid_ver "in%0d, ", $i;
  }
  printf $fid_ver "in%0d; \n", $pi_cnt;

  printf $fid_ver "input signed [%0d:0] ", $wo_size-1; 
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_ver "w%0d, ", $i;
  }
  printf $fid_ver "w%0d; \n", $po_cnt;

  printf $fid_ver "output signed [%0d:0] ", $po_size-1; 
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_ver "out%0d, ", $i;
  }
  printf $fid_ver "out%0d; \n", $po_cnt;

  printf $fid_ver "\n";
}

sub write_module_io{
  my ($fid_ver, $module_name, $pi_cnt, $po_cnt, $pi_size, $po_size) = @_;
  
  printf $fid_ver "module %0s (", $module_name;
  foreach my $i (1 .. $pi_cnt){
    printf $fid_ver "in%0d, ", $i;
  }
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_ver "out%0d, ", $i;
  }
  printf $fid_ver "out%0d); \n", $po_cnt;

  printf $fid_ver "\n";
  
  printf $fid_ver "input signed [%0d:0] ", $pi_size-1;
  foreach my $i (1 .. $pi_cnt-1){
    printf $fid_ver "in%0d, ", $i;
  }
  printf $fid_ver "in%0d; \n", $pi_cnt;

  printf $fid_ver "output signed [%0d:0] ", $po_size-1; 
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_ver "out%0d, ", $i;
  }
  printf $fid_ver "out%0d; \n", $po_cnt;

  printf $fid_ver "\n";
}


sub write_verilog_activation_function{
  my ($fid_ver, $layer_index, $po_cnt, $po_size, $po_width_arr_ref, $act_fun_arr_ref) = @_;
  my @act_fun_arr = @ {$act_fun_arr_ref};
  my @po_width_arr = @ {$po_width_arr_ref};

  if ($act_fun_arr[$layer_index] eq "relu"){
    foreach my $i (1 .. $po_cnt){
      if ($po_width_arr[$i] >= $po_size){
        printf $fid_ver "assign out%0d = (neuron%0d < 0) ? %0d'd0 : neuron%0d[%0d:%0d]; \n", $i, $i, $po_size, $i, $po_width_arr[$i]-1, $po_width_arr[$i]-$po_size; 
      }
      else{
        printf $fid_ver "assign out%0d = (neuron%0d < 0) ? %0d'd0 : neuron%0d[%0d:0]; \n", $i, $i, $po_size, $i, $po_size-1; 
      }
    }
  }
  elsif ($act_fun_arr[$layer_index] eq "lin"){
    foreach my $i (1 .. $po_cnt){
      printf $fid_ver "assign out%0d = neuron%0d[%0d:%0d]; \n", $i, $i, $po_width_arr[$i]-1, $po_width_arr[$i]-$po_size; 
    }
  }
  elsif ($act_fun_arr[$layer_index] eq "satlins"){
    foreach my $i (1 .. $po_cnt){
      printf $fid_ver "assign out%0d = (neuron%0d <= \$signed(-%0d'd%0d)) ? -%0d'd%0d : (neuron%0d >= \$signed(%0d'd%0d)) ? %0d'd%0d : neuron%0d[%0d:0]; \n", $i, $i, $po_width_arr[$i], 2**($po_size-1), $po_size, 2**($po_size-1), $i, $po_width_arr[$i], 2**($po_size-1)-1, $po_size, 2**($po_size-1)-1, $i, $po_size-1; 
    }
  }
  elsif ($act_fun_arr[$layer_index] eq "satlin"){
    foreach my $i (1 .. $po_cnt){
      printf $fid_ver "assign out%0d = (neuron%0d <= \$signed(-%0d'd%0d)) ? %0d'd0 : (neuron%0d >= \$signed(%0d'd%0d)) ? %0d'd%0d : {1'b0, !neuron%0d[%0d], neuron%0d[%0d:1]}; \n", $i, $i, $po_width_arr[$i], 2**($po_size-1), $po_size, $i, $po_width_arr[$i], 2**($po_size-1)-1, $po_size, 2**($po_size-1)-1, $i, $po_width_arr[$i]-1, $i, $po_size-2; 
    }
  }
}

sub write_layer_verilog_weight_input{
  my ($fid_ver, $layer_index, $wo_size, $layer_arr_ref, $act_fun_arr_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};

  my $po_cnt = $layer_arr[$layer_index];
  my $pi_cnt = $layer_arr[$layer_index-1];
  my $po_size = $out_width;
  my $quan_size = $quan_bit;
  
  my $pi_size;
  if ($layer_index == 2){
    $pi_size = $in_width;
  }
  else{
    $pi_size = $out_width;
  }

  #print "pi_cnt: $pi_cnt \n";
  #print "po_cnt: $po_cnt \n";
  #print "layer_index: $layer_index \n";

  my @po_width_arr = ();
  foreach my $i (1 .. $po_cnt){
    $po_width_arr[$i] = $in_width + $quan_bit + POSIX::ceil(log($pi_cnt)/log(2)) + 1;
  }

  #Write the module, inputs, and outputs
  my $layer_name = "ann_layer" . $layer_index;
  write_layer_module_io_wei($fid_ver, $layer_name, $pi_cnt, $po_cnt, $pi_size, $po_size, $wo_size);

  #Write the variables
  foreach my $i (1 .. $po_cnt){
    printf $fid_ver "wire signed [%0d:0] neuron%0d; \n", $po_width_arr[$i]-1, $i;
  }
  
  printf $fid_ver "\n";
  
  #Compute the neuron output
  foreach my $i (1 .. $po_cnt){
    printf $fid_ver "assign neuron%0d = ", $i;
    foreach my $j (1 .. $pi_cnt){
      printf $fid_ver "in%0d*w%0d[%0d:%0d] + ", $j, $i, ($j*$quan_size-1), ($j-1)*$quan_size;
    }
    printf $fid_ver "w%0d[%0d:%0d]; \n", $i, (($pi_cnt+1)*$quan_size-1), $pi_cnt*$quan_size;
  }
  printf $fid_ver "\n";

  #Write the activation function and the outputs
  write_verilog_activation_function($fid_ver, $layer_index, $po_cnt, $po_size, \@po_width_arr, $act_fun_arr_ref);

  #if ($act_fun_arr[$layer_index] eq "relu"){
  #  foreach my $i (1 .. $po_cnt){
  #    printf $fid_ver "assign out%0d = (neuron%0d < 0) ? %0d'd0 : neuron%0d[%0d:%0d]; \n", $i, $i, $po_size, $i, $po_width, $po_width-$po_size+1; 
  #  }
  #}
  #elsif ($act_fun_arr[$layer_index] eq "lin"){
  #  foreach my $i (1 .. $po_cnt){
  #    printf $fid_ver "assign out%0d = neuron%0d[%0d:%0d]; \n", $i, $i, $po_width, $po_width-$po_size+1; 
  #  }
  #}
  #elsif ($act_fun_arr[$layer_index] eq "satlins"){
  #  foreach my $i (1 .. $po_cnt){
  #    printf $fid_ver "assign out%0d = (neuron%0d <= \$signed(-%0d'd%0d)) ? -%0d'd%0d : (neuron%0d >= \$signed(%0d'd%0d)) ? %0d'd%0d : neuron%0d[%0d:0]; \n", $i, $i, $po_width+1, 2**($po_size-1), $po_size, 2**($po_size-1), $i, $po_width+1, 2**($po_size-1)-1, $po_size, 2**($po_size-1)-1, $i, $po_size-1; 
  #  }
  #}
  #elsif ($act_fun_arr[$layer_index] eq "satlin"){
  #  foreach my $i (1 .. $po_cnt){
  #    printf $fid_ver "assign out%0d = (neuron%0d <= \$signed(-%0d'd%0d)) ? %0d'd0 : (neuron%0d >= \$signed(%0d'd%0d)) ? %0d'd%0d : (neuron%0d[%0d:1] + \$signed(%0d'd%0d)); \n", $i, $i, $po_width+1, 2**($po_size-1), $po_size, $i, $po_width+1, 2**($po_size-1)-1, $po_size, 2**($po_size-1)-1, $i, $po_size, $po_size, 2**($po_size-2); 
  #  }
  #}

  printf $fid_ver "\n";
  printf $fid_ver "endmodule \n";
  printf $fid_ver "\n";
}

sub write_layer_verilog_shift_adds{
  my ($file_path, $file_name, $fid_ver, $layer_index, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};

  my $pi_size = ($layer_index == 2) ? $in_width : $out_width;
  my $pi_cnt = $layer_arr[$layer_index-1];
  my $po_cnt = $layer_arr[$layer_index];
  my $quan_size = $quan_bit;
  my $po_size = $out_width;

  #print "pi_cnt: $pi_cnt \n";
  #print "po_cnt: $po_cnt \n";
  #print "layer_index: $layer_index \n";

  my $max_po_width = 0;
  my @po_width_arr = ();
  my @muladd_width_arr = ();
  foreach my $i (1 .. $po_cnt){
    #Add the weights
    my $weight_sum = 0;
    foreach my $j (1 .. $pi_cnt){
      $weight_sum += abs($weight_mat[$layer_index-1][$i][$j]);
    }
    if ($weight_sum){
      $muladd_width_arr[$i] = POSIX::ceil(log(2**$pi_size*$weight_sum)/log(2));
    }
    else{
      $muladd_width_arr[$i] = 0;
    }

    #Add the bias
    $weight_sum += abs($weight_mat[$layer_index-1][$i][$pi_cnt+1]);
    $po_width_arr[$i] = POSIX::floor(log($weight_sum)/log(2))+2;

    if ($po_width_arr[$i] > $max_po_width){
      $max_po_width = $po_width_arr[$i];
    }
  }

  #Setting the bit-width of each neuron to the maximum bit-width in case of linear and RELU 
  if (${$act_fun_arr_ref}[$layer_index] eq "lin" or ${$act_fun_arr_ref}[$layer_index] eq "relu"){
    foreach my $i (1 .. $po_cnt){
      $po_width_arr[$i] = $max_po_width;
    }
  }

  #Write the module, inputs, and outputs
  my $layer_name = "ann_layer" . $layer_index;
  write_module_io($fid_ver, $layer_name, $pi_cnt, $po_cnt, $pi_size, $po_size);

  foreach my $i (1 .. $po_cnt){
    if ($weight_mat[$layer_index-1][$i][$pi_cnt+1] > 0){
      my $signed_width = POSIX::floor(log($weight_mat[$layer_index-1][$i][$pi_cnt+1])/log(2))+2;
      printf $fid_ver "wire signed [%0d:0] b%0d; assign b%0d = %0d'd%0d; \n", $signed_width-1, $i, $i, $signed_width, $weight_mat[$layer_index-1][$i][$pi_cnt+1];
    }
    elsif ($weight_mat[$layer_index-1][$i][$pi_cnt+1] < 0){
      my $signed_width = POSIX::ceil(log(abs($weight_mat[$layer_index-1][$i][$pi_cnt+1]))/log(2))+1;
      printf $fid_ver "wire signed [%0d:0] b%0d; assign b%0d = -%0d'd%0d; \n", $signed_width-1, $i, $i, $signed_width, abs($weight_mat[$layer_index-1][$i][$pi_cnt+1]);
    }
    if ($muladd_width_arr[$i]){
      printf $fid_ver "wire signed [%0d:0] sa_out%0d; \n", $muladd_width_arr[$i]-1, $i;
    }
    if ($po_width_arr[$i] >= $po_size){
      printf $fid_ver "wire signed [%0d:0] neuron%0d; \n", $po_width_arr[$i]-1, $i;
    }
    else{
      printf $fid_ver "wire signed [%0d:0] neuron%0d; \n", $po_size-1, $i;
    }
  } 
  printf $fid_ver "\n";

  printf $fid_ver "%0s_layer%0d layer%0d_sa_ins(", $file_name, $layer_index, $layer_index;
  
  foreach my $i (1 .. $pi_cnt-1){
    printf $fid_ver ".x%0d(in%0d), ", $i, $i;
  }
  printf $fid_ver ".x%0d(in%0d) ", $pi_cnt, $pi_cnt;
  my $out_cnt = 0;
  foreach my $i (1 .. $po_cnt){
    if ($muladd_width_arr[$i]){
      $out_cnt++;
      printf $fid_ver ", .y%0d(sa_out%0d)", $out_cnt, $i;
    }
  }
  printf $fid_ver "); \n";
  printf $fid_ver "\n";
  
  #Generate the neuron and add the bias value
  foreach my $i (1 .. $po_cnt){
    if ($weight_mat[$layer_index-1][$i][$pi_cnt+1] and $muladd_width_arr[$i]){
      printf $fid_ver "assign neuron%0d = (sa_out%0d>>>%0d) + b%0d; \n", $i, $i, $pi_size-1, $i;
    }
    elsif(!$weight_mat[$layer_index-1][$i][$pi_cnt+1] and $muladd_width_arr[$i]){
      printf $fid_ver "assign neuron%0d = (sa_out%0d>>>%0d); \n", $i, $i, $pi_size-1;
    }
    elsif($weight_mat[$layer_index-1][$i][$pi_cnt+1] and !$muladd_width_arr[$i]){
      printf $fid_ver "assign neuron%0d = b%0d; \n", $i, $i;
    }
  }
  printf $fid_ver "\n";

  #Write the activation function and the outputs
  write_verilog_activation_function($fid_ver, $layer_index, $po_cnt, $po_size, \@po_width_arr, $act_fun_arr_ref);

  printf $fid_ver "\n";
  printf $fid_ver "endmodule \n";
  printf $fid_ver "\n";

  return (\@muladd_width_arr, \@po_width_arr);
}

sub generate_verilog_code_weight_input{
  my ($file_path, $file_name, $file_verilog, $layer_cnt, $layer_arr_ref, $act_fun_arr_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @act_fun_arr = @ {$act_fun_arr_ref};
 
  my $pi_cnt = $layer_arr[1];
  my $po_cnt = $layer_arr[$layer_cnt];
  my $pi_size = $in_width;
  my $po_size = $out_width;
  my $quan_size = $quan_bit;

  my @wo_size = ();
  for (my $i=2; $i<=$layer_cnt; $i++){
    $wo_size[$i] = ($layer_arr[$i-1]+1)*$quan_size; #+1 for the BIAS
  }

  print "[INFO] Generating the Verilog file... \n";

  open (my $fid_ver, '>', $file_verilog);

  #Write the module, inputs, and outputs
  write_module_io_wei($fid_ver, $file_name, $pi_cnt, $po_cnt, $pi_size, $po_size, $layer_cnt, \@layer_arr, \@wo_size);

  #Write the variables  
  for (my $i=3; $i<=$layer_cnt; $i++){
    printf $fid_ver "wire signed [%0d:0] ", $po_size-1;
    foreach my $j (1 .. $layer_arr[$i-1]-1){
      printf $fid_ver "l%0do%0d, ", $i-1, $j;
    }
    printf $fid_ver "l%0do%0d; \n", $i-1, $layer_arr[$i-1];
  }

  printf $fid_ver "\n";
  
  #Instantiate the layers
  for (my $i=2; $i<=$layer_cnt; $i++){
    printf $fid_ver "ann_layer%0d layer%0d_ins (", $i, $i;
    foreach my $j (1 .. $layer_arr[$i-1]){
      if ($i == 2){
        printf $fid_ver ".in%0d(in%0d), ", $j, $j;
      }
      else{
        printf $fid_ver ".in%0d(l%0do%0d), ", $j, $i-1, $j;
      }
    }

    foreach my $j (1 .. $layer_arr[$i]){
      printf $fid_ver ".w%0d(w%0d_%0d), ", $j, $i, $j;
    }

    foreach my $j (1 .. $layer_arr[$i]-1){
      if ($i == $layer_cnt){
        printf $fid_ver ".out%0d(out%0d), ", $j, $j;
      }
      else{
        printf $fid_ver ".out%0d(l%0do%0d), ", $j, $i, $j;
      }
    }
    if ($i == $layer_cnt){
      printf $fid_ver ".out%0d(out%0d)); \n", $layer_arr[$i], $layer_arr[$i];
    }
    else{
      printf $fid_ver ".out%0d(l%0do%0d)); \n", $layer_arr[$i], $i, $layer_arr[$i];
    }
  }

  printf $fid_ver "\n";
  printf $fid_ver "endmodule \n";
  printf $fid_ver "\n";

  #Write the modules for layers
  for (my $i=2; $i<=$layer_cnt; $i++){
    write_layer_verilog_weight_input($fid_ver, $i, $wo_size[$i], \@layer_arr, \@act_fun_arr);
  }

  close ($fid_ver);  
}

sub write_layer_verilog_weight_constant{
  my ($file_path, $file_name, $fid_ver, $layer_index, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};

  my $pi_size = ($layer_index == 2) ? $in_width : $out_width;
  my $pi_cnt = $layer_arr[$layer_index-1];
  my $po_cnt = $layer_arr[$layer_index];
  my $quan_size = $quan_bit;
  my $po_size = $out_width;

  my $fid_bias;
  my $file_bias;
  my $fid_weight;
  my $file_weight;
  if ($the_wout){
    $file_bias = $file_path . $file_name . "_layer" . $layer_index . "_bias.cmat";
    open ($fid_bias, '>', $file_bias);
    printf $fid_bias ".r %0d \n", $po_cnt;
    printf $fid_bias ".c %0d \n", 1;
    
    $file_weight = $file_path . $file_name . "_layer" . $layer_index . "_weight.cmat";
    open ($fid_weight, '>', $file_weight);
    printf $fid_weight ".r %0d \n", $po_cnt;
    printf $fid_weight ".c %0d \n", $pi_cnt;
  }

  #print "pi_cnt: $pi_cnt \n";
  #print "po_cnt: $po_cnt \n";
  #print "layer_index: $layer_index \n";

  my $max_po_width = 0;
  my @po_width_arr = ();
  my @muladd_width_arr = ();
  foreach my $i (1 .. $po_cnt){
    #Add the weights
    my $weight_sum = 0;
    foreach my $j (1 .. $pi_cnt){
      $weight_sum += abs($weight_mat[$layer_index-1][$i][$j]);
    }
    if ($weight_sum){
      $muladd_width_arr[$i] = POSIX::ceil(log(2**$pi_size*$weight_sum)/log(2));
    }
    else{
      $muladd_width_arr[$i] = 0;
    }

    #Add the bias
    $weight_sum += abs($weight_mat[$layer_index-1][$i][$pi_cnt+1]);
    $po_width_arr[$i] = POSIX::floor(log($weight_sum)/log(2))+2;

    if ($po_width_arr[$i] > $max_po_width){
      $max_po_width = $po_width_arr[$i];
    }
  }

  #Setting the bit-width of each neuron to the maximum bit-width in case of linear and RELU 
  if (${$act_fun_arr_ref}[$layer_index] eq "lin" or ${$act_fun_arr_ref}[$layer_index] eq "relu"){
    foreach my $i (1 .. $po_cnt){
      $po_width_arr[$i] = $max_po_width;
    }
  }

  #Write the module, inputs, and outputs
  my $layer_name = "ann_layer" . $layer_index;
  write_module_io($fid_ver, $layer_name, $pi_cnt, $po_cnt, $pi_size, $po_size);

  #Write the variables
  foreach my $i (1 .. $po_cnt){
    foreach my $j (1 .. $pi_cnt+1){
      if ($weight_mat[$layer_index-1][$i][$j]){
        if ($weight_mat[$layer_index-1][$i][$j] > 0){
          my $signed_width = POSIX::floor(log($weight_mat[$layer_index-1][$i][$j])/log(2))+2;
          printf $fid_ver "wire signed [%0d:0] w%0d_%0d; assign w%0d_%0d = %0d'd%0d; \n", $signed_width-1, $i, $j, $i, $j, $signed_width, $weight_mat[$layer_index-1][$i][$j];
        }
        elsif ($weight_mat[$layer_index-1][$i][$j] < 0){
          my $signed_width = POSIX::ceil(log(abs($weight_mat[$layer_index-1][$i][$j]))/log(2))+1;
          printf $fid_ver "wire signed [%0d:0] w%0d_%0d; assign w%0d_%0d = -%0d'd%0d; \n", $signed_width-1, $i, $j, $i, $j, $signed_width, abs($weight_mat[$layer_index-1][$i][$j]);
        }
      }
    }
    if ($muladd_width_arr[$i]){
      printf $fid_ver "wire signed [%0d:0] muladd%0d; \n", $muladd_width_arr[$i]-1, $i;
    }
    if ($po_width_arr[$i] >= $po_size){
      printf $fid_ver "wire signed [%0d:0] neuron%0d; \n", $po_width_arr[$i]-1, $i;
    }
    else{
      printf $fid_ver "wire signed [%0d:0] neuron%0d; \n", $po_size-1, $i;
    }
    printf $fid_ver "\n";
  }
  
  #Compute the muladd output
  foreach my $i (1 .. $po_cnt){
    #Muladd
    if ($muladd_width_arr[$i]){
      my $first_nonzero = 0;
      printf $fid_ver "assign muladd%0d =", $i;
      foreach my $j (1 .. $pi_cnt){
        if ($weight_mat[$layer_index-1][$i][$j]){
          if (!$first_nonzero){
            $first_nonzero = 1;
            printf $fid_ver " in%0d*w%0d_%0d", $j, $i, $j;
          }
          else{
            printf $fid_ver " + in%0d*w%0d_%0d", $j, $i, $j;
          }
        }

        if ($the_wout){printf $fid_weight "%0d ", $weight_mat[$layer_index-1][$i][$j];}
      }
      printf $fid_ver "; \n";
    }

    #Neuron
    if ($weight_mat[$layer_index-1][$i][$pi_cnt+1] and $muladd_width_arr[$i]){
      printf $fid_ver "assign neuron%0d = (muladd%0d>>>%0d) + w%0d_%0d; \n", $i, $i, $pi_size-1, $i, $pi_cnt+1;
    }
    elsif (!$weight_mat[$layer_index-1][$i][$pi_cnt+1] and $muladd_width_arr[$i]){
      printf $fid_ver "assign neuron%0d = (muladd%0d>>>%0d); \n", $i, $i, $pi_size-1;
    }
    elsif ($weight_mat[$layer_index-1][$i][$pi_cnt+1] and !$muladd_width_arr[$i]){
      printf $fid_ver "assign neuron%0d = w%d_%d; \n", $i, $i, $pi_cnt+1;
    }
 
    if ($the_wout){printf $fid_weight "\n";}
    if ($the_wout){printf $fid_bias "%0d \n", $weight_mat[$layer_index-1][$i][$pi_cnt+1];}
  }
  printf $fid_ver "\n";

  #Write the activation function and the outputs
  write_verilog_activation_function($fid_ver, $layer_index, $po_cnt, $po_size, \@po_width_arr, $act_fun_arr_ref);

  printf $fid_ver "\n";
  printf $fid_ver "endmodule \n";
  printf $fid_ver "\n";

  if ($the_wout){
    printf $fid_bias ".e \n";
    close ($fid_bias);
    
    printf $fid_weight ".e \n";
    close ($fid_weight);
  }

  return (\@po_width_arr);
}

sub generate_verilog_code_shift_adds{
  my ($file_path, $file_name, $file_verilog, $ver_file_cnt, $ver_file_arr_ref, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};
  my @ver_file_arr = @ {$ver_file_arr_ref};
 
  my @muladd_width_mat = ();
  my @neuron_width_mat = ();
  
  my $pi_size = $in_width;
  my $po_size = $out_width;
  my $pi_cnt = $layer_arr[1];
  my $po_cnt = $layer_arr[$layer_cnt];

  print "[INFO] Generating the Verilog file... \n";

  open (my $fid_ver, '>', $file_verilog);

  foreach (my $i=2; $i<=$layer_cnt; $i++){
    my $ver_file = $file_name . "_layer" . $i . ".v";
    printf $fid_ver "`include \"%0s\" \n", $ver_file;
    
    $ver_file_cnt++;
    $ver_file_arr[$ver_file_cnt] = $ver_file;
  }
  printf $fid_ver "\n";

  #Write the module, inputs, and outputs
  write_module_io($fid_ver, $file_name, $pi_cnt, $po_cnt, $pi_size, $po_size);

  #Write the variables  
  if ($layer_cnt > 2){
    for (my $i=3; $i<=$layer_cnt; $i++){
      printf $fid_ver "wire signed [%0d:0] ", $po_size-1;
      foreach my $j (1 .. $layer_arr[$i-1]-1){
        printf $fid_ver "l%0do%0d, ", $i-1, $j;
      }
      printf $fid_ver "l%0do%0d; \n", $i-1, $layer_arr[$i-1];
    }
    printf $fid_ver "\n";
  }
  
  #Instantiate the layers
  for (my $i=2; $i<=$layer_cnt; $i++){
    printf $fid_ver "ann_layer%0d layer%0d_ins (", $i, $i;
    foreach my $j (1 .. $layer_arr[$i-1]){
      if ($i == 2){
        printf $fid_ver ".in%0d(in%0d), ", $j, $j;
      }
      else{
        printf $fid_ver ".in%0d(l%0do%0d), ", $j, $i-1, $j;
      }
    }

    foreach my $j (1 .. $layer_arr[$i]-1){
      if ($i == $layer_cnt){
        printf $fid_ver ".out%0d(out%0d), ", $j, $j;
      }
      else{
        printf $fid_ver ".out%0d(l%0do%0d), ", $j, $i, $j;
      }
    }
    if ($i == $layer_cnt){
      printf $fid_ver ".out%0d(out%0d)); \n", $layer_arr[$i], $layer_arr[$i];
    }
    else{
      printf $fid_ver ".out%0d(l%0do%0d)); \n", $layer_arr[$i], $i, $layer_arr[$i];
    }
  }

  printf $fid_ver "\n";
  printf $fid_ver "endmodule \n";
  printf $fid_ver "\n";

  #Write the modules for layers
  for (my $i=2; $i<=$layer_cnt; $i++){
    my ($muladd_width_arr_ref, $neuron_width_arr_ref) = write_layer_verilog_shift_adds($file_path, $file_name, $fid_ver, $i, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref);
    @{${\@muladd_width_mat}[$i]} = @{$muladd_width_arr_ref};
    @{${\@neuron_width_mat}[$i]} = @{$neuron_width_arr_ref};
  }

  close ($fid_ver);
  
  return ($ver_file_cnt, \@ver_file_arr, \@muladd_width_mat, \@neuron_width_mat);
}

sub generate_verilog_code_weight_constant{
  my ($file_path, $file_name, $file_verilog, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};
 
  my @neuron_width_mat = ();

  my $pi_cnt = $layer_arr[1];
  my $po_cnt = $layer_arr[$layer_cnt];
  my $pi_size = $in_width;
  my $po_size = $out_width;

  print "[INFO] Generating the Verilog file... \n";

  open (my $fid_ver, '>', $file_verilog);

  #Write the module, inputs, and outputs
  write_module_io($fid_ver, $file_name, $pi_cnt, $po_cnt, $pi_size, $po_size);

  #Write the variables
  if ($layer_cnt > 2){
    for (my $i=3; $i<=$layer_cnt; $i++){
      printf $fid_ver "wire signed [%0d:0] ", $po_size-1;
      foreach my $j (1 .. $layer_arr[$i-1]-1){
        printf $fid_ver "l%0do%0d, ", $i-1, $j;
      }
      printf $fid_ver "l%0do%0d; \n", $i-1, $layer_arr[$i-1];
    }
    printf $fid_ver "\n";
  }
  
  #Instantiate the layers
  for (my $i=2; $i<=$layer_cnt; $i++){
    printf $fid_ver "ann_layer%0d layer%0d_ins (", $i, $i;
    foreach my $j (1 .. $layer_arr[$i-1]){
      if ($i == 2){
        printf $fid_ver ".in%0d(in%0d), ", $j, $j;
      }
      else{
        printf $fid_ver ".in%0d(l%0do%0d), ", $j, $i-1, $j;
      }
    }

    foreach my $j (1 .. $layer_arr[$i]-1){
      if ($i == $layer_cnt){
        printf $fid_ver ".out%0d(out%0d), ", $j, $j;
      }
      else{
        printf $fid_ver ".out%0d(l%0do%0d), ", $j, $i, $j;
      }
    }
    if ($i == $layer_cnt){
      printf $fid_ver ".out%0d(out%0d)); \n", $layer_arr[$i], $layer_arr[$i];
    }
    else{
      printf $fid_ver ".out%0d(l%0do%0d)); \n", $layer_arr[$i], $i, $layer_arr[$i];
    }
  }

  printf $fid_ver "\n";
  printf $fid_ver "endmodule \n";
  printf $fid_ver "\n";

  #Write the modules for layers
  for (my $i=2; $i<=$layer_cnt; $i++){
    my ($neuron_width_arr_ref) = write_layer_verilog_weight_constant($file_path, $file_name, $fid_ver, $i, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref);
    @{${\@neuron_width_mat}[$i]} = @{$neuron_width_arr_ref};
  }

  close ($fid_ver);
  
  return (\@neuron_width_mat);
}

sub generate_synth_script{
  my ($file_path, $file_name, $layer_cnt, $ver_file_cnt, $ver_file_arr_ref) = @_;
  my  @ver_file_arr = @ {$ver_file_arr_ref};

  my $ver_file = "";
  my $lef_file = "";
  my $lib_file = "";
  my $lib_path = "";
  my $op_conds = "";
  my $saif_cmd = "";

  print "[INFO] Generating the synthesis script... \n";
  my $file_script = $file_path . $file_name . "_synth_" . $the_lib . ".script";
  open (my $fid_script, '>', $file_script);

  if ($the_lib eq "tsmc40"){
    $lef_file = "/vlsi/kits/tsmc/lib/40lp/TSMCHOME/digital/Back_End/lef/tcbn40lpbwp_120c/lef/HVH_0d5_0/tcbn40lpbwp_6lm3X2ZRDL.lef";
    $lib_file = "tcbn40lpbwptc.lib"; 
    $lib_path = "/vlsi/kits/tsmc/lib/40lp/TSMCHOME/digital/Front_End/timing_power_noise/NLDM/tcbn40lpbwp_200a";
    $op_conds = "NCCOM";
  }
  elsif ($the_lib eq "tsmc180"){
    $lef_file = "/work/kits/tsmc/lib/180bcd/TSMCHOME/digital/Back_End/lef/tcb018bcdgp2a_110a/lef/tcb018bcdgp2a_6lm.lef";
    $lib_file = "tcb018bcdgp2atc.lib"; 
    $lib_path = "/vlsi/kits/tsmc/lib/180bcd/TSMCHOME/digital/Front_End/timing_power_noise/NLDM/tcb018bcdgp2a_110a";
    $op_conds = "NCCOM";
  }
  elsif ($the_lib eq "xfab"){
    $lef_file = "/vlsi/kits/xfab/xkit/xh018/diglibs/D_CELLS_HD/v3_0/LEF/v3_0_0/xh018_D_CELLS_HD.lef";
    $lib_file = "{D_CELLS_HD_LPMOS_typ_1_80V_25C.lib IO_CELLS_C1V8_LPMOS_typ_1_80V_1_80V_25C.lib}";
    $lib_path = "{/vlsi/kits/xfab/xkit/xh018/diglibs/D_CELLS_HD/v3_0/liberty_LPMOS/v3_0_0/PVT_1_80V_range /vlsi/kits/xfab/xkit/xh018/diglibs/IO_CELLS_C1V8/v1_1/liberty_LPMOS/v1_1_0/PVT_1_80V_1_80V_range}";
    $op_conds = "typ_1_80V_25C";
  }

  foreach my $i (1 .. $ver_file_cnt){
    $ver_file .= $ver_file_arr[$i] . " ";
  }

  if ($the_tech){
    $saif_cmd = "read_saif " . $file_name . ".saif";
  }

  my $the_message = <<END_OF_MESSAGE;  
set_attribute lib_search_path $lib_path
set_attribute library $lib_file
set_attribute lp_power_analysis_effort high
read_hdl -v2001 {$ver_file}
elaborate $file_name
define_clock -period 80000 -fall 80 -rise 80 -name clk -domain domain_clk [find /des* -port ports_in/clk]
set_attribute slew {100 100 200 200} [find -clock clk]
external_delay -input 500 -clock [find -clock clk] -edge_rise [find /des* -port ports_in/*]
external_delay -output 500 -clock [find -clock clk] -edge_rise [find /des* -port ports_out/*]
set_attribute operating_conditions $op_conds
$saif_cmd
synthesize -to_mapped -effort high
report timing > $file_name\_time.report
report gates > $file_name\_gates.report
report area > $file_name\_area.report
report power > $file_name\_power.report
write_encounter design $file_name -basename encounter/$file_name -lef $lef_file
write_sdf -edges check_edge > $file_name.sdf
write_sdc -no_split > $file_name.sdc 

END_OF_MESSAGE

  printf $fid_script "$the_message";
  close ($fid_script);
}

sub compute_output{
  my ($layer_cnt, $layer_arr_ref, $weight_mat_ref, $neuron_width_mat_ref, $act_fun_arr_ref, $test_in_arr_ref, $is_permit) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};
  my @act_fun_arr = @ {$act_fun_arr_ref};
  my @neuron_width_mat = @ {$neuron_width_mat_ref};

  my $pi_cnt = $layer_arr[1];
  my $po_cnt = $layer_arr[$layer_cnt];

  my @out_arr = ();
  my @in_arr = @ {dclone($test_in_arr_ref)};
 
  my @neuron_arr = ();

  #if ($is_permit){
  #  print "ann_in: ";
  #  foreach my $i (1 .. $pi_cnt){
  #    print "$in_arr[$i] ";
  #  }
  #  print "\n";
  #  sleep 1;
  #}
  
  for (my $layer_index=1; $layer_index<$layer_cnt; $layer_index++){
    my $in_cnt = $layer_arr[$layer_index];
    my $out_cnt = $layer_arr[$layer_index+1];
    my $muladd_rs = ($layer_index == 1) ? $in_width : $out_width;
    #print "muladd_rs: $muladd_rs \n";

    if ($is_permit){
      print "* Layer $layer_index Computations: \n";
      print "in_arr: ";
      foreach my $i (1 .. $in_cnt){
        print "$in_arr[$i] ";
      }
      print "\n";
    }

    @neuron_arr = ();
    foreach my $out_index (1 .. $out_cnt){
      my $the_neuron = 0;
      #print "the_muladd: ";
      foreach my $in_index (1 .. $in_cnt){
        $the_neuron += $in_arr[$in_index]*$weight_mat[$layer_index][$out_index][$in_index];
      }
      #print "$the_neuron quan_neuron: ";
      $the_neuron = POSIX::floor($the_neuron/2**($muladd_rs-1));
      $the_neuron += $weight_mat[$layer_index][$out_index][$in_cnt+1];
      $neuron_arr[$out_index] = $the_neuron;
      #print "the_neuron: $the_neuron ";

      my $neuron_width = $neuron_width_mat[$layer_index+1][$out_index];
      #print "neuron_width $neuron_width ";
      #print "out_width $out_width ";

      if ($act_fun_arr[$layer_index+1] eq "lin"){
        if ($neuron_width > $out_width){
          $out_arr[$out_index] = POSIX::floor($the_neuron/2**($neuron_width-$out_width));
        }
        else{
          $out_arr[$out_index] = $the_neuron;
        }
      }
      elsif ($act_fun_arr[$layer_index+1] eq "relu"){
        if ($the_neuron < 0){
          $out_arr[$out_index] = 0;
        }
        else{
          if ($neuron_width > $out_width){
            $out_arr[$out_index] = POSIX::floor($the_neuron/2**($neuron_width-$out_width));
          }
          else{
            $out_arr[$out_index] = $the_neuron;
          }
        }
      }
      elsif ($act_fun_arr[$layer_index+1] eq "satlin"){
        if ($the_neuron <= (-1)*2**($out_width-1)){
          $out_arr[$out_index] = 0;
        }
        elsif ($the_neuron >= 2**($out_width-1)-1){
          $out_arr[$out_index] = 2**($out_width-1)-1;
        }
        else{
          $out_arr[$out_index] = POSIX::floor($the_neuron/2) + 2**($out_width-2);
        }
      }
      elsif ($act_fun_arr[$layer_index+1] eq "satlins"){
        if ($the_neuron <= (-1)*2**($out_width-1)){
          $out_arr[$out_index] = (-1)*2**($out_width-1);
        }
        elsif ($the_neuron >= 2**($out_width-1)-1){
          $out_arr[$out_index] = 2**($out_width-1)-1;
        }
        else{
          $out_arr[$out_index] = $the_neuron;
        }
      }
      #print "\n";
      #sleep 1;
    }
    if ($is_permit){print_array_contents("neuron_arr", $out_cnt, @neuron_arr);}
    @in_arr = @ {dclone(\@out_arr)};
    @out_arr = ();
  }

  #if ($is_permit){
  #  print "ann_out: ";
  #  foreach my $i (1 .. $po_cnt){
  #    print "$in_arr[$i] ";
  #  }
  #  print "\n";
  #  sleep 1;
  #}
  
  return (@in_arr);
}

sub classification_compare_actual_expected_outputs{
  my ($test_cnt, $po_cnt, $act_out_arr_ref, $test_out_arr_ref) = @_;
  my @act_out_arr = @ {$act_out_arr_ref};
  my @test_out_arr = @ {$test_out_arr_ref};

  #print "act_out_arr: ";
  #foreach my $i (1 .. $po_cnt){
  #  print "$act_out_arr[$i] ";
  #}
  #print "\n";
  #print "test_out_arr: ";
  #foreach my $i (1 .. $po_cnt){
  #  print "$test_out_arr[$i] ";
  #}
  #print "\n";
  #sleep 1;

  my $test_out = 0;
  my $test_label = 1;

  #Classification 
  if ($acc_tech == 1){
    my $acc_index = 0;
    my $max_index_cnt = 0;
    my @max_index_arr = ();
    my $max_val = (-1)*9**9**9;
    foreach my $i (1 .. $po_cnt){
      if ($test_out_arr[$i] > $max_val){
        $max_index_cnt = 0;
        @max_index_arr = ();
        $max_val = $test_out_arr[$i];

        $max_index_cnt++;
        $max_index_arr[$max_index_cnt] = $i;
      }
      elsif ($test_out_arr[$i] == $max_val){
        $max_index_cnt++;
        $max_index_arr[$max_index_cnt] = $i;
      }

      if ($act_out_arr[$i] == 1){
        $acc_index = $i;
      }
    }

    #print "max_index_cnt: $max_index_cnt \n";
    #print "acc_index: $acc_index \n";

    if ($max_index_cnt == 1){
      if ($acc_index == $max_index_arr[1]){
        $test_label = 1;
        #print "[INFO] For the $test_cnt test, the actual output is the same as the expected value! \n";
      }
      else{
        $test_label = 0;
        #print "[INFO] For the $test_cnt test, the actual output is not the same as the expected value! \n";
      }
    }
    else{
      $test_label = -1;
      #print "[INFO] For the $test_cnt test, multiple outputs have the same maximum value! \n";
    }

    $test_out = $max_index_arr[1];
  }

  return ($test_out, $test_label);
}

sub generate_test_patterns{
  my ($file_path, $file_name, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $neuron_width_mat_ref, $act_fun_arr_ref) = @_;

  my $the_acc = 0;
  my $tie_cnt = 0;
  my $test_cnt = 0;
  my @test_out_arr = ();
  my $pi_cnt = ${$layer_arr_ref}[1];
  my $po_cnt = ${$layer_arr_ref}[$layer_cnt];

  my $file_test_in = $file_path . $file_name . ".inputs";
  my $file_test_out = $file_path . $file_name . ".outputs";
  my $file_label_out = $file_path . $file_name . ".results";
  open (my $fid_in, '>', $file_test_in);
  open (my $fid_out, '>', $file_test_out);
  open (my $fid_label, '>', $file_label_out);
  if ($the_test == 0){
    $test_cnt = $test_num;
    foreach my $i (1 .. $test_num){
      my @test_in_arr = ();
      foreach my $j (1 .. $pi_cnt){
        my $the_num = (rand() > 0.5) ? int(2**($in_width-1)*rand()) : (-1)*int((2**($in_width-1)-1)*rand());
        $test_in_arr[$j] = $the_num;
        #print "the_num: $the_num \n";
        #sleep 1;
        
        if ($the_num < 0){
          $the_num += 2**$in_width;
        }

        my (@the_rep) = int2bin($the_num, $in_width);
        foreach (my $k=$in_width; $k>0; $k--){
          printf $fid_in "%0d", $the_rep[$k];
        }
      }
      printf $fid_in "\n";

      (@test_out_arr) = compute_output($layer_cnt, $layer_arr_ref, $weight_mat_ref, $neuron_width_mat_ref, $act_fun_arr_ref, \@test_in_arr, 0);
      foreach my $i (1 .. $po_cnt){
        my (@the_rep) = int2sign($test_out_arr[$i], $out_width);
        foreach my $j (1 .. $out_width){
          printf $fid_out "%0d", $the_rep[$out_width-$j+1];
        }
      }
      printf $fid_out "\n";
    }
  }
  elsif ($the_test == 1){
    my $cls_acc_cnt = 0;

    if (open (my $file_header, '<:encoding(UTF-8)', $dv_file)){
      while (my $the_line = <$file_header>){
        chomp $the_line;

        my $is_err = 0;
        my $in_cnt = 0;
        my $last_index = 0;
        my $init_index = -1;
        my @test_in_arr = ();
        my $lline = length($the_line);

        #Extract the actual inputs from the dv_file
        while ($in_cnt != $pi_cnt){
          $init_index = skip_spaces_forward($the_line, $init_index+1);
          $last_index= $init_index;
          while (substr($the_line, $last_index, 1) ne "," and substr($the_line, $last_index, 1) ne ";"){
            $last_index++;

            if ($last_index >= $lline){
              $is_err = 1;
              last;
            }
          }

          if ($is_err){
            last;
          }
          else{
            my $the_num = substr($the_line, $init_index, $last_index-$init_index) + 0.0;
            #print "the_num: $the_num \n";
            #sleep 1;

            $in_cnt++;
            $test_in_arr[$in_cnt] = $the_num;
            
            if ($the_num < 0){
              $the_num += 2**$in_width;
            }

            my (@the_rep) = int2bin($the_num, $in_width);
            foreach (my $k=$in_width; $k>0; $k--){
              printf $fid_in "%0d", $the_rep[$k];
            }

            $init_index = $last_index;
          }
        }
        printf $fid_in "\n";

        if (!$is_err){
          $test_cnt++;
          #Extract the actual outputs from the dv_file 
          if ($acc_tech){
            my $out_cnt = 0;
            my @act_out_arr = ();
            $init_index = index($the_line, ";");

            while ($out_cnt != $po_cnt){
              $init_index = skip_spaces_forward($the_line, $init_index+1);
              $last_index= $init_index;
              while (substr($the_line, $last_index, 1) ne "," and substr($the_line, $last_index, 1) ne " "){
                $last_index++;

                if ($last_index >= $lline){
                  $is_err = 1;
                  last;
                }
              }

              if ($is_err){
                last;
              }
              else{
                my $the_num = substr($the_line, $init_index, $last_index-$init_index) + 0.0;
                #print "the_num: $the_num \n";
                #sleep 1;

                $out_cnt++;
                $init_index = $last_index;
                $act_out_arr[$out_cnt] = $the_num;
              }
            }

            if (!$is_err){
              #print_array_contents("test_in_arr", $pi_cnt, @test_in_arr);
              (@test_out_arr) = compute_output($layer_cnt, $layer_arr_ref, $weight_mat_ref, $neuron_width_mat_ref, $act_fun_arr_ref, \@test_in_arr, 0);
              #print_array_contents("test_out_arr", $po_cnt, @test_out_arr);
              #sleep 1;
              foreach my $i (1 .. $po_cnt){
                my (@the_rep) = int2sign($test_out_arr[$i], $out_width);
                foreach my $j (1 .. $out_width){
                  printf $fid_out "%0d", $the_rep[$out_width-$j+1];
                }
              }
              printf $fid_out "\n";

              #Compare the actual and expected outputs
              my ($test_out, $test_label) = classification_compare_actual_expected_outputs($test_cnt, $po_cnt, \@act_out_arr, \@test_out_arr);
              printf $fid_label "%0d ", $test_out;
              if ($test_label == 1){
                $cls_acc_cnt++;
                printf $fid_label "TRUE \n";
              }
              elsif ($test_label == 0){
                printf $fid_label "FALSE \n";
              }
              else{
                printf $fid_label "TIE \n";
                $tie_cnt++;
              }
            }
            else{
              print "[ERROR] Number of test outputs in the $dv_file is less than the number of outputs in the ANN design! \n";
            }
          }
        }
        else{
          print "[ERROR] Number of test inputs in the $dv_file is less than the number of inputs in the ANN design! \n";
        }
      }

      close ($file_header);
    }
    else{
      print "[ERROR] Could not open the $dv_file! \n";
    }

    if ($acc_tech){
      #Classification
      if ($acc_tech == 1){
        $the_acc = $cls_acc_cnt/$test_cnt;
        print "[INFO] $cls_acc_cnt test points out of $test_cnt give the right results with an accuracy of $the_acc where there are $tie_cnt ties! \n";
      }
    }
  }

  close ($fid_in);
  close ($fid_out);
  close ($fid_label);

  return ($test_cnt, $the_acc);
}

sub generate_saif_script{
  my ($file_path, $file_name) = @_;

  my $saif_name = $file_name . ".saif";
  my $script_name = $file_name . "_saif.script";
  my $file_script = $file_path . $script_name;
  open (my $fid_script, '>', $file_script);
  my $the_message = <<END_OF_MESSAGE;
dumpsaif -scope $file_name -output $saif_name 
run
dumpsaif -end 

END_OF_MESSAGE

  printf $fid_script "$the_message";
  close ($fid_script);
}

sub generate_testbench{
  my ($file_path, $file_name, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $weight_flt_mat_ref, $neuron_width_mat_ref, $act_fun_arr_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};
  my @neuron_width_mat = @ {$neuron_width_mat_ref};

  print "[INFO] Generating the test-bench... \n";
  #for (my $i=2; $i<=$layer_cnt; $i++){
  #  print "Width of the neurons at the $i layer: ";
  #  foreach my $j (1 .. $layer_arr[$i]){
  #    print "$neuron_width_mat[$i][$j] ";
  #  }
  #  print "\n";
  #}

  my $pi_cnt = $layer_arr[1];
  my $po_cnt = $layer_arr[$layer_cnt];
  my $pi_size = $in_width;
  my $po_size = $out_width;

  my $file_in = $file_name . ".inputs";
  my $file_out = $file_name . ".outputs";
  my ($test_cnt, $the_acc) = generate_test_patterns($file_path, $file_name, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $neuron_width_mat_ref, $act_fun_arr_ref);
 
  my $module_tb = $file_name . "_tb";
  my $file_tb = $file_path . $module_tb . ".v";
  open (my $fid_tb, '>', $file_tb);

  #writing the module
  printf $fid_tb "module %0s (); \n", $module_tb;

  #writing the procedure
  printf $fid_tb "\n";
  printf $fid_tb "integer fid_out, test_index; \n";
  printf $fid_tb "reg [%0d:0] test_in_reg [0:%0d]; \n", $pi_cnt*$in_width-1, $test_cnt-1;
  printf $fid_tb "reg [%0d:0] test_out_reg [0:%0d]; \n", $po_cnt*$out_width-1, $test_cnt-1;
  printf $fid_tb "reg signed [%0d:0] ", $in_width-1;
  foreach my $i (1 .. $pi_cnt-1){
    printf $fid_tb "in%0d, ", $i;
  }
  printf $fid_tb "in%0d;\n", $pi_cnt;
  printf $fid_tb "reg signed [%0d:0] ", $out_width-1;
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_tb "test_out%0d, ", $i;
  }
  printf $fid_tb "test_out%0d;\n", $po_cnt;
  printf $fid_tb "wire signed [%0d:0] ", $out_width-1;
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_tb "out%0d, ", $i;
  }
  printf $fid_tb "out%0d;\n", $po_cnt;
  printf $fid_tb "\n";

  printf $fid_tb "initial begin \n";
  printf $fid_tb "  fid_out = \$fopen(\"sim.out\", \"w\"); \n";
  printf $fid_tb "  \$readmemb(\"%0s\", test_in_reg); \n", $file_in;
  printf $fid_tb "  \$readmemb(\"%0s\", test_out_reg); \n", $file_out;
  printf $fid_tb "\n";
  printf $fid_tb "  for (test_index=0; test_index<%0d; test_index=test_index+1) begin \n", $test_cnt;
  foreach my $i (1 .. $pi_cnt-1){
    printf $fid_tb "    in%0d = test_in_reg[test_index][%0d:%0d]; \n", $i, $in_width*($pi_cnt-$i+1)-1, $in_width*($pi_cnt-$i);
    printf $fid_tb "    \$fwrite(fid_out, \"%%d, \", in%0d); \n", $i;
  }
  printf $fid_tb "    in%0d = test_in_reg[test_index][%0d:0]; \n", $pi_cnt, $in_width-1;
  printf $fid_tb "    \$fwrite(fid_out, \"%%d; \", in%d); \n", $pi_cnt;
  printf $fid_tb "\n";
  printf $fid_tb "    \#10; \n";
  printf $fid_tb "\n";
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_tb "    test_out%0d = test_out_reg[test_index][%0d:%0d]; \n", $i, $out_width*($po_cnt-$i+1)-1, $out_width*($po_cnt-$i);
    printf $fid_tb "    \$fwrite(fid_out, \"%%d, \", test_out%0d); \n", $i;
    printf $fid_tb "    if (test_out%0d !== out%0d) begin \n", $i, $i;
    printf $fid_tb "      \$display(\"[ERROR] %0d. output is not the same as the expected on the %%d test pattern!\", test_index); \$stop; \n", $i;
    printf $fid_tb "    end \n";
  }
  printf $fid_tb "    test_out%0d = test_out_reg[test_index][%0d:0]; \n", $po_cnt, $out_width-1;
  printf $fid_tb "    \$fwrite(fid_out, \"%%d \\n \", test_out%0d); \n", $po_cnt;
  printf $fid_tb "    if (test_out%0d !== out%0d) begin \n", $po_cnt, $po_cnt;
  printf $fid_tb "      \$display(\"[ERROR] %0d. output is not the same as the expected on the %%d test pattern!\", test_index); \$stop; \n", $po_cnt;
  printf $fid_tb "    end \n";
  printf $fid_tb "  end \n";
  printf $fid_tb "\n";
  printf $fid_tb "  \$fclose(fid_out); \n";
  printf $fid_tb "  \$display(\"[INFO] ANN design has just been verified!\"); \n";
  printf $fid_tb "  \$stop; \n";
  printf $fid_tb "end \n";
  printf $fid_tb "\n";

  #writing the dut
  printf $fid_tb "%0s %0s ( \n", $file_name, $file_name;
  foreach my $i (1 .. $pi_cnt){
    printf $fid_tb "    .in%0d(in%0d), \n", $i, $i;
  }
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_tb "    .out%0d(out%0d), \n", $i, $i;
  }
  printf $fid_tb "    .out%0d(out%0d)); \n", $po_cnt, $po_cnt;
  printf $fid_tb "\n";

  printf $fid_tb "endmodule \n";

  close ($fid_tb);

  generate_saif_script($file_path, $file_name);

  return ($the_acc);
}

sub sort_array{
  my ($the_cnt, @the_arr) = @_;

  my @sorted_arr = ();

  foreach my $i (1 .. $the_cnt){
    $the_arr[$i][0] = 1;
  }

  for (my $i=1; $i<=$the_cnt-1; $i++){
    for (my $j=$i+1; $j<=$the_cnt; $j++){
      if ($the_arr[$i][2] < $the_arr[$j][2]){
        $the_arr[$j][0]++;
      }
      else{
        $the_arr[$i][0]++;
      }
    }
  }

  foreach my $i (1 ..  $the_cnt){
    $sorted_arr[$the_arr[$i][0]][1] = $the_arr[$i][1];
    $sorted_arr[$the_arr[$i][0]][2] = $the_arr[$i][2];
  }

  return (@sorted_arr);
}

sub generate_layer_output_mcm{
  my ($fid_layer, $layer_index, $out_index, $pi_cnt, $weight_mat_ref) = @_;
  my @weight_mat = @ {$weight_mat_ref};

  my $add_cnt = 0;
  my @add_arr = ();

  foreach my $i (1 .. $pi_cnt){
    if ($weight_mat[$layer_index-1][$out_index][$i]){
      $add_cnt++;
      if ($weight_mat[$layer_index-1][$out_index][$i] > 0){
        $add_arr[$add_cnt][1] = "wp" . $weight_mat[$layer_index-1][$out_index][$i] . "_mul_x" . $i;
      }
      else{
        $add_arr[$add_cnt][1] = "wm" . abs($weight_mat[$layer_index-1][$out_index][$i]) . "_mul_x" . $i;
      }
      $add_arr[$add_cnt][2] = abs($weight_mat[$layer_index-1][$out_index][$i]);
    }
  }

  my $say_add = $add_cnt ? $add_cnt - 1 : 0;

  while (1){
    if ($add_cnt > 1){
      #print "add_arr: ";
      #foreach my $i (1 .. $add_cnt){
      #  print "$add_arr[$i][1] ";
      #}
      #print "\n";
      #sleep 1;
      my (@sorted_arr) = sort_array($add_cnt, @add_arr);
      #print "sorted_arr: ";
      #foreach my $i (1 .. $add_cnt){
      #  print "$sorted_arr[$i][1] ";
      #}
      #print "\n";
      #sleep 1;

      my $new_add_cnt = 0;
      my @new_add_arr = ();
      my $last_one = ($add_cnt % 2) ? $add_cnt-1 : $add_cnt;

      for (my $i=1; $i<=$last_one; $i=$i+2){
        $new_add_cnt++;
        $new_add_arr[$new_add_cnt][1] = "(" . $sorted_arr[$i][1] . " + " . $sorted_arr[$i+1][1] . ")";
        $new_add_arr[$new_add_cnt][2] = $sorted_arr[$i][2] + $sorted_arr[$i+1][2];
      }
      if ($add_cnt % 2){
        $new_add_cnt++;
        $new_add_arr[$new_add_cnt][1] = "(" . $sorted_arr[$add_cnt][1] . ")";
        $new_add_arr[$new_add_cnt][2] = $sorted_arr[$add_cnt][2];
      }

      $add_cnt = $new_add_cnt;
      @add_arr = @ {dclone(\@new_add_arr)};
    }
    else{
      last;
    }
  }

  printf $fid_layer "assign y%0d = %0s; \n", $out_index, $add_arr[1][1];

  return ($say_add);
}

sub generate_verilog_code_layer_mcm_blocks{
  my ($fid_layer, $say_add, $layer_mod, $layer_index, $pi_cnt, $po_cnt, $weight_mat_ref, $muladd_width_mat_ref) = @_;
  my @weight_mat = @ {$weight_mat_ref};
  my @muladd_width_mat = @ {$muladd_width_mat_ref};

  #Module name
  printf $fid_layer "\n";
  printf $fid_layer "module %0s (", $layer_mod;
  foreach my $i (1 .. $pi_cnt){
    printf $fid_layer "x%0d, ", $i;
  }
  foreach my $i (1 .. $po_cnt-1){
    printf $fid_layer "y%0d, ", $i;
  }
  printf $fid_layer "y%0d); \n", $po_cnt;
  printf $fid_layer "\n";

  #Inputs
  printf $fid_layer "input signed [%0d:0] ", $in_width-1;
  foreach my $i (1 .. $pi_cnt-1){
    printf $fid_layer "x%0d, ", $i;
  }
  printf $fid_layer "x%0d; \n", $pi_cnt;
  #Outputs
  foreach my $i (1 .. $po_cnt){
    printf $fid_layer "output signed [%0d:0] y%0d; \n", $muladd_width_mat[$layer_index][$i]-1, $i;
  }
  printf $fid_layer "\n";
  #Wires
  foreach my $i (1 .. $pi_cnt){
    my $uni_cnt = 0;
    my @uni_arr = ();
    foreach my $j (1 .. $po_cnt){
      my $the_cons = $weight_mat[$layer_index-1][$j][$i];
      if ($the_cons){
        if (!is_inside_numeric_array($the_cons, $uni_cnt, @uni_arr)){
          $uni_cnt++;
          $uni_arr[$uni_cnt] = $the_cons;
          my $the_width = POSIX::ceil(log(abs($the_cons))/log(2)) + $in_width;

          if ($the_cons > 0){
            printf $fid_layer "wire signed [%0d:0] wp%0d_mul_x%0d; \n", $the_width-1, $the_cons, $i; 
          }
          else{
            printf $fid_layer "wire signed [%0d:0] wm%0d_mul_x%0d; \n", $the_width-1, abs($the_cons), $i; 
          }
        }
      }
    }
  }
  printf $fid_layer "\n";
  #MCM Blocks
  foreach my $i (1 .. $pi_cnt){
    my $mcm_mod = $layer_mod . "_in" . $i;
    printf $fid_layer "%0s mcm_in%d_ins (.x1(x%0d), ", $mcm_mod, $i, $i;

    my $uni_cnt = 0;
    my @uni_arr = ();
    my $first_nonzero = 0;
    foreach my $j (1 .. $po_cnt){
      my $the_cons = $weight_mat[$layer_index-1][$j][$i];

      if ($the_cons){
        if (!is_inside_numeric_array($the_cons, $uni_cnt, @uni_arr)){
          $uni_cnt++;
          $uni_arr[$uni_cnt] = $the_cons;

          if ($first_nonzero){
            if ($the_cons > 0){
              printf $fid_layer ", .p%0dx(wp%0d_mul_x%0d)", $the_cons, $the_cons, $i;
            }
            else{
              printf $fid_layer ", .m%0dx(wm%0d_mul_x%0d)", abs($the_cons), abs($the_cons), $i;
            }
          }
          else{
            $first_nonzero = 1;
            if ($the_cons > 0){
              printf $fid_layer ".p%0dx(wp%0d_mul_x%0d)", $the_cons, $the_cons, $i;
            }
            else{
              printf $fid_layer ".m%0dx(wm%0d_mul_x%0d)", abs($the_cons), abs($the_cons), $i;
            }
          }
        }
      }
    }

    printf $fid_layer "); \n";
  }
  printf $fid_layer "\n";
  #Outputs
  foreach my $out_index (1 .. $po_cnt){
    $say_add += generate_layer_output_mcm($fid_layer, $layer_index, $out_index, $pi_cnt, $weight_mat_ref);
  }

  printf $fid_layer "\n";
  printf $fid_layer "endmodule \n";
  printf $fid_layer "\n";

  return ($say_add);
}

sub generate_verilog_code_layer_cavm_blocks{
  my ($fid_layer, $layer_mod, $layer_index, $pi_cnt, $po_cnt, $weight_mat_ref, $muladd_width_mat_ref, $all_zero_arr_ref) = @_;
  my @weight_mat = @ {$weight_mat_ref};
  my @all_zero_arr = @ {$all_zero_arr_ref};
  my @muladd_width_mat = @ {$muladd_width_mat_ref};
  
  my $out_cnt = 0;

  #Module name
  printf $fid_layer "\n";
  printf $fid_layer "module %0s (", $layer_mod;
  foreach my $i (1 .. $pi_cnt-1){
    printf $fid_layer "x%0d, ", $i;
  }
  printf $fid_layer "x%0d ", $pi_cnt;
  foreach my $i (1 .. $po_cnt){
    if (!$all_zero_arr[$i]){
      $out_cnt++;
      printf $fid_layer ", y%0d", $out_cnt;
    }
  }
  printf $fid_layer "); \n";
  printf $fid_layer "\n";

  #Inputs
  printf $fid_layer "input signed [%0d:0] ", $in_width-1;
  foreach my $i (1 .. $pi_cnt-1){
    printf $fid_layer "x%0d, ", $i;
  }
  printf $fid_layer "x%0d; \n", $pi_cnt;
  #Outputs
  $out_cnt = 0;
  foreach my $i (1 .. $po_cnt){
    if (!$all_zero_arr[$i]){
      $out_cnt++;
      printf $fid_layer "output signed [%0d:0] y%0d; \n", $muladd_width_mat[$layer_index][$i]-1, $out_cnt;
    }
  }
  printf $fid_layer "\n";
  #CAVM Blocks
  $out_cnt = 0;
  foreach my $i (1 .. $po_cnt){
    if (!$all_zero_arr[$i]){
      $out_cnt++;
      my $cavm_mod = $layer_mod . "_out" . $i;
      printf $fid_layer "%0s cavm_out%d_ins (", $cavm_mod, $i;
      foreach my $j (1 .. $pi_cnt){
        printf $fid_layer ".x%d(x%d), ", $j, $j;
      }
      printf $fid_layer ".y1(y%d)); \n", $out_cnt;
    }
  }
  printf $fid_layer "\n";
  printf $fid_layer "endmodule \n";
  printf $fid_layer "\n";
}

sub file_extract_add_count{
  my ($file_result) = @_;

  my $add_cnt = 0;

  if (open (my $file_header, '<:encoding(UTF-8)', $file_result)){
    my $the_index = 0;

    while (my $the_line = <$file_header>){
      chomp $the_line;

      if (index($the_line, "* Number of operations:") != -1){
        $the_index = index($the_line, ":");
        $the_index = skip_spaces_forward($the_line, $the_index+1);

        $add_cnt = substr($the_line, $the_index, length($the_line)-$the_index) + 0.0;
        #print "add_cnt: $add_cnt \n";
        last;
      }
    }

    close ($file_header);
  }
  else{
    print "[ERROR] Could not open the $file_result file! \n";
  }

  return ($add_cnt);
}

sub generate_verilog_code_layer_mcm{
  my ($file_path, $file_name, $path_mcm, $path_high2low, $say_add, $ver_file_cnt, $ver_file_arr_ref, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $muladd_width_mat_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};
  my @ver_file_arr = @ {$ver_file_arr_ref};

  my $the_cmd;
  my $fid_bias;
  my $file_bias;
  my $fid_weight;
  my $file_weight;
  for (my $layer_index=2; $layer_index<=$layer_cnt; $layer_index++){
    my $po_cnt = $layer_arr[$layer_index];
    my $pi_cnt = $layer_arr[$layer_index-1];

    my $layer_mod = $file_name . "_layer" . $layer_index;
    my $layer_ver = $file_path . $layer_mod . ".v";
    open (my $fid_layer, '>', $layer_ver);

    foreach my $in_index (1 .. $pi_cnt){
      my $mcm_name = $file_name . "_layer" . $layer_index . "_in" . $in_index;
      my $mcm_result = $file_path . $mcm_name . ".result";
      my $file_mcm = $file_path . $mcm_name . ".mc";
      my $mcm_ver = $mcm_name . ".v";

      printf $fid_layer "`include \"%0s\"\n", $mcm_ver;
      
      open (my $fid_mcm, '>', $file_mcm);
      foreach my $out_index (1 .. $po_cnt){
        if ($weight_mat[$layer_index-1][$out_index][$in_index]){
          printf $fid_mcm "%0d \n", $weight_mat[$layer_index-1][$out_index][$in_index];
        }
      }
      close ($fid_mcm);

      if ($the_aim eq "area"){
        $the_cmd = $path_mcm . " " . $file_mcm . " 0";
      }
      else{
        $the_cmd = $path_mcm . " " . $file_mcm . " 1";
      }
      #print "mcm_cmd: $the_cmd \n";
      system($the_cmd);
      $say_add += file_extract_add_count($mcm_result);
      
      #Generate the Verilog file
      $the_cmd = $path_high2low . " " . $mcm_result . " " . $in_width;
      #print "high2low_cmd: $the_cmd \n";
      system($the_cmd);

      $ver_file_cnt++;
      $ver_file_arr[$ver_file_cnt] = $mcm_ver;
    }

    ($say_add) = generate_verilog_code_layer_mcm_blocks($fid_layer, $say_add, $layer_mod, $layer_index, $pi_cnt, $po_cnt, $weight_mat_ref, $muladd_width_mat_ref);

    close ($fid_layer);
  }

  return ($say_add, $ver_file_cnt, \@ver_file_arr);
}

sub generate_verilog_code_layer_cavm{
  my ($file_path, $file_name, $path_cavm, $path_high2low, $say_add, $ver_file_cnt, $ver_file_arr_ref, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $muladd_width_mat_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};
  my @ver_file_arr = @ {$ver_file_arr_ref};

  my $the_cmd;
  my $fid_bias;
  my $file_bias;
  my $fid_weight;
  my $file_weight;
  for (my $layer_index=2; $layer_index<=$layer_cnt; $layer_index++){
    my $po_cnt = $layer_arr[$layer_index];
    my $pi_cnt = $layer_arr[$layer_index-1];

    my @all_zero_arr = ();

    my $layer_mod = $file_name . "_layer" . $layer_index;
    my $layer_ver = $file_path . $layer_mod . ".v";
    open (my $fid_layer, '>', $layer_ver);

    foreach my $out_index (1 .. $po_cnt){
      my $cavm_name = $file_name . "_layer" . $layer_index . "_out" . $out_index;
      my $cavm_result = $file_path . $cavm_name . ".result";
      my $file_cavm = $file_path . $cavm_name . ".vm";
      my $cavm_ver = $cavm_name . ".v";
 
      my $is_all_zero = 1;
      open (my $fid_cavm, '>', $file_cavm);
      foreach my $in_index (1 .. $pi_cnt){
        if ($weight_mat[$layer_index-1][$out_index][$in_index]){
          $is_all_zero = 0;
        }
        printf $fid_cavm "%0d \n", $weight_mat[$layer_index-1][$out_index][$in_index];
      }
      printf $fid_cavm "\n";
      close ($fid_cavm);

      #print "is_all_zero: $is_all_zero \n";
      $all_zero_arr[$out_index] = $is_all_zero;

      if (!$is_all_zero){
        printf $fid_layer "`include \"%0s\"\n", $cavm_ver;

        #Solve the CAVM problem
        if ($the_aim eq "area"){
          $the_cmd = $path_cavm . " " . $file_cavm . " 0";
        }
        else{
          $the_cmd = $path_cavm . " " . $file_cavm . " 1";
        }
        #print "cavm_cmd: $the_cmd \n";
        system($the_cmd);
        $say_add += file_extract_add_count($cavm_result);
        
        #Generate the Verilog file
        $the_cmd = $path_high2low . " " . $cavm_result . " " . $in_width;
        #print "high2low_cmd: $the_cmd \n";
        system($the_cmd);

        $ver_file_cnt++;
        $ver_file_arr[$ver_file_cnt] = $cavm_ver;
      }
    }

    generate_verilog_code_layer_cavm_blocks($fid_layer, $layer_mod, $layer_index, $pi_cnt, $po_cnt, $weight_mat_ref, $muladd_width_mat_ref, \@all_zero_arr);

    close ($fid_layer);
  }

  return ($say_add, $ver_file_cnt, \@ver_file_arr);
}

sub generate_verilog_code_layer_cmvm{
  my ($file_path, $file_name, $path_hcmvm, $path_high2low, $say_add, $layer_cnt, $layer_arr_ref, $weight_mat_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};

  my $fid_bias;
  my $file_bias;
  my $fid_weight;
  my $file_weight;
  my $the_cmd = "";

  for (my $layer_index=2; $layer_index<=$layer_cnt; $layer_index++){
    my $po_cnt = $layer_arr[$layer_index];
    my $pi_cnt = $layer_arr[$layer_index-1];

    $file_bias = $file_path . $file_name . "_layer" . $layer_index . "_bias.cmat";
    open ($fid_bias, '>', $file_bias);
    printf $fid_bias ".r %0d \n", $po_cnt;
    printf $fid_bias ".c %0d \n", 1;
    
    $file_weight = $file_path . $file_name . "_layer" . $layer_index . ".cmat";
    open ($fid_weight, '>', $file_weight);
    printf $fid_weight ".r %0d \n", $po_cnt;
    printf $fid_weight ".c %0d \n", $pi_cnt;

    foreach my $i (1 .. $po_cnt){
      foreach my $j (1 .. $pi_cnt){
        printf $fid_weight "%0d ", $weight_mat[$layer_index-1][$i][$j];
      }
      printf $fid_weight "\n";
      printf $fid_bias "%0d \n", $weight_mat[$layer_index-1][$i][$pi_cnt+1];
    }

    printf $fid_bias ".e \n";
    close ($fid_bias);
    
    printf $fid_weight ".e \n";
    close ($fid_weight);

    #run the cmvm algorithm
    my $cmat_name = $file_name . "_layer" . $layer_index;
    my $cmvm_result = $file_path . $cmat_name . ".result";
    if ($the_rep eq "binary"){
      $the_cmd = $path_hcmvm . " " . $file_weight . " 0";
    }
    else{
      $the_cmd = $path_hcmvm . " " . $file_weight . " 1";
    }
    #print "the_cmd: $the_cmd \n";
    system ($the_cmd);
    $say_add += file_extract_add_count($cmvm_result);

    #Run the high2low code
    $the_cmd = $path_high2low . " " . $cmvm_result . " " . $in_width;
    #print "the_cmd: $the_cmd \n";
    system ($the_cmd);
  }

  return ($say_add);
}

sub file_read_validation_data{
  my ($layer_cnt, $layer_arr_ref) = @_;

  my $test_cnt = 0;
  my @test_in_mat = ();
  my @test_out_mat = ();
  
  my $pi_cnt = ${$layer_arr_ref}[1];
  my $po_cnt = ${$layer_arr_ref}[$layer_cnt];

  if (open (my $file_header, '<:encoding(UTF-8)', $val_file)){
    while (my $the_line = <$file_header>){
      chomp $the_line;

      my $is_err = 0;
      my $in_cnt = 0;
      my $last_index = 0;
      my $init_index = -1;
      my @test_in_arr = ();
      my $lline = length($the_line);

      #Extract the actual inputs from the val_file
      while ($in_cnt != $pi_cnt){
        $init_index = skip_spaces_forward($the_line, $init_index+1);
        $last_index= $init_index;
        while (substr($the_line, $last_index, 1) ne "," and substr($the_line, $last_index, 1) ne ";"){
          $last_index++;

          if ($last_index >= $lline){
            $is_err = 1;
            last;
          }
        }

        if ($is_err){
          last;
        }
        else{
          my $the_num = substr($the_line, $init_index, $last_index-$init_index) + 0.0;
          #print "the_num: $the_num \n";
          #sleep 1;

          $in_cnt++;
          $test_in_arr[$in_cnt] = $the_num;
          
          $init_index = $last_index;
        }
      }

      if (!$is_err){
        $test_cnt++;
        @{${\@test_in_mat}[$test_cnt]} = @test_in_arr;

        #Extract the test outputs from the val_file 
        my $out_cnt = 0;
        my @test_out_arr = ();
        $init_index = index($the_line, ";");

        while ($out_cnt != $po_cnt){
          $init_index = skip_spaces_forward($the_line, $init_index+1);
          $last_index= $init_index;
          while (substr($the_line, $last_index, 1) ne "," and substr($the_line, $last_index, 1) ne " "){
            $last_index++;

            if ($last_index >= $lline){
              $is_err = 1;
              last;
            }
          }

          if ($is_err){
            last;
          }
          else{
            my $the_num = substr($the_line, $init_index, $last_index-$init_index) + 0.0;
            #print "the_num: $the_num \n";
            #sleep 1;

            $out_cnt++;
            $init_index = $last_index;
            $test_out_arr[$out_cnt] = $the_num;
          }
        }

        if (!$is_err){
          @{${\@test_out_mat}[$test_cnt]} = @test_out_arr;
        }
        else{
          print "[ERROR] Number of test outputs in the $val_file is less than the number of outputs in the ANN design! \n";
        }
      }
      else{
        print "[ERROR] Number of test inputs in the $val_file is less than the number of inputs in the ANN design! \n";
      }
    }

    close ($file_header);
  }
  else{
    print "[ERROR] Could not open the $val_file! \n";
  }

  return ($test_cnt, \@test_in_mat, \@test_out_mat);
}

sub compute_neurons_width{
  my ($layer_cnt, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};
  my @act_fun_arr = @ {$act_fun_arr_ref};

  my $nzd_cost = 0;
  my $max_neuron_width = 0;
  my @neuron_width_mat = ();

  for (my $layer_index=2; $layer_index<=$layer_cnt; $layer_index++){
    my $pi_cnt = $layer_arr[$layer_index-1];
    my $po_cnt = $layer_arr[$layer_index];

    foreach my $i (1 .. $po_cnt){
      my $weight_sum = 0;
      #Add the weights and bias
      foreach my $j (1 .. $pi_cnt+1){
        #print "layer_index: $layer_index po_index: $i pi_index: $j \n";
        $weight_sum += abs($weight_mat[$layer_index-1][$i][$j]);

        my ($nzd_cnt, @csd_rep) = find_nonzero_digits_csd($weight_mat[$layer_index-1][$i][$j]);
        $nzd_cost += $nzd_cnt;
      }
      $neuron_width_mat[$layer_index][$i] = POSIX::floor(log($weight_sum)/log(2))+2;

      if ($neuron_width_mat[$layer_index][$i] > $max_neuron_width){
        $max_neuron_width = $neuron_width_mat[$layer_index][$i];
      }
    }

    if ($act_fun_arr[$layer_index] eq "lin" or $act_fun_arr[$layer_index] eq "relu"){
      for my $i (1 .. $po_cnt){
        $neuron_width_mat[$layer_index][$i] = $max_neuron_width;
      }
    }
  }

  return ($nzd_cost, \@neuron_width_mat);
}

sub compute_accuracy{
  my ($layer_cnt, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref, $neuron_width_mat_ref, $test_cnt, $test_in_mat_ref, $test_out_mat_ref) = @_;

  my $the_acc = 0;
  my $cls_acc_cnt = 0;

  my $po_cnt = ${$layer_arr_ref}[$layer_cnt];
  
  #my @weight_mat = @ {$weight_mat_ref};
  #"new_weight_mat: ";
  #for (my $i=2; $i<=$layer_cnt; $i++){
  #  foreach my $j (1 .. $po_cnt){
  #    foreach my $k (1 .. $pi_cnt){
  #      print "$weight_mat[$i-1][$j][$k] "
  #    }
  #    print "\n";
  #  }
  #  print "\n";
  #}
  #print "\n";

  foreach my $test_index (1 .. $test_cnt){
    my (@ann_out_arr) = compute_output($layer_cnt, $layer_arr_ref, $weight_mat_ref, $neuron_width_mat_ref, $act_fun_arr_ref, \@{${$test_in_mat_ref}[$test_index]}, 0);
    if ($acc_tech == 1){
      my ($test_out, $test_label) = classification_compare_actual_expected_outputs($test_index, $po_cnt, \@{${$test_out_mat_ref}[$test_index]}, \@ann_out_arr);
      if ($test_label == 1){
        $cls_acc_cnt++;
      }
    }
  }

  if ($acc_tech){
    #Classification
    if ($acc_tech == 1){
      #print "Number of correct results: $cls_acc_cnt \n";
      $the_acc = $cls_acc_cnt/$test_cnt;
    }
  }

  return ($cls_acc_cnt, $the_acc);
}

sub tune_weights{
  my ($layer_cnt, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref, $test_cnt, $test_in_mat_ref, $test_out_mat_ref) = @_;
  my @layer_arr = @ {$layer_arr_ref};
  my @weight_mat = @ {$weight_mat_ref};

  print "[INFO] Tuning the constant weights and biases on the validation data set... \n";
  my ($nzd_cost, $neuron_width_mat_ref) = compute_neurons_width($layer_cnt, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref);
  my ($cls_acc, $the_acc) = compute_accuracy($layer_cnt, $layer_arr_ref, $weight_mat_ref, $act_fun_arr_ref, $neuron_width_mat_ref, $test_cnt, $test_in_mat_ref, $test_out_mat_ref);

  my $best_acc = $the_acc;
  my $best_cost = $nzd_cost;
  my @best_weight_mat = @ {dclone($weight_mat_ref)};
  print "[INFO] Initial accuracy: $best_acc Initial total number of non-zero digits: $best_cost \n";

  my $time_expired = 0;
  my $sol_improved = 1;
  my $init_round_time = time();
  while ($sol_improved and !$time_expired){
    $sol_improved = 0;

    for (my $layer_index=2; $layer_index<=$layer_cnt; $layer_index++){
      my $pi_cnt = $layer_arr[$layer_index-1];
      my $po_cnt = $layer_arr[$layer_index];

      foreach my $out_index (1 .. $po_cnt){
        foreach my $in_index (1 .. $pi_cnt+1){
          my $the_weight = $best_weight_mat[$layer_index-1][$out_index][$in_index];
          my ($nzd_cnt, @nzd_arr) = find_nonzero_digits_csd($the_weight);
          #print "Original weight: $the_weight Original NZD: $nzd_cnt \n";

          for (my $the_diff=-2; $the_diff<=2; $the_diff++){
            if ($the_diff){
              my $new_weight = $the_weight + $the_diff;
              my ($new_nzd_cnt, @new_nzd_arr) = find_nonzero_digits_csd($new_weight);
              #print "New weight: $new_weight New NZD: $new_nzd_cnt \n";
              #sleep 1;

              if ($new_nzd_cnt < $nzd_cnt){
                my @new_weight_mat = @ {dclone(\@best_weight_mat)};
                $new_weight_mat[$layer_index-1][$out_index][$in_index] = $new_weight;
                my ($new_cls_acc_cnt, $new_acc) = compute_accuracy($layer_cnt, $layer_arr_ref, \@new_weight_mat, $act_fun_arr_ref, $neuron_width_mat_ref, $test_cnt, $test_in_mat_ref, $test_out_mat_ref);
                #print "New Accuracy: $new_acc \n";
                #sleep 1;
                if ($new_acc >= $best_acc){
                  $sol_improved = 1;
                  $best_acc = $new_acc;
                  $best_cost -= $nzd_cnt - $new_nzd_cnt;
                  $best_weight_mat[$layer_index-1][$out_index][$in_index] = $new_weight;
                  #print "[INFO] Hurray!!! A better solution is found with $new_cls_acc_cnt accurate values, $best_acc accuracy, and $best_cost cost \n";
                }
              }
              elsif ($new_nzd_cnt == $nzd_cnt){
                my @new_weight_mat = @ {dclone(\@best_weight_mat)};
                $new_weight_mat[$layer_index-1][$out_index][$in_index] = $new_weight;
                my ($new_cls_acc_cnt, $new_acc) = compute_accuracy($layer_cnt, $layer_arr_ref, \@new_weight_mat, $act_fun_arr_ref, $neuron_width_mat_ref, $test_cnt, $test_in_mat_ref, $test_out_mat_ref);
                #print "New Accuracy: $new_acc \n";
                #sleep 1;
                if ($new_acc > $best_acc){
                  $sol_improved = 1;
                  $best_acc = $new_acc;
                  $best_cost -= $nzd_cnt - $new_nzd_cnt;
                  $best_weight_mat[$layer_index-1][$out_index][$in_index] = $new_weight;
                  #print "[INFO] Hurray!!! A better solution is found with $new_cls_acc_cnt accurate values, $best_acc accuracy, and $best_cost cost \n";
                }
              }
            }
          }

          if (time()-$init_round_time > $tune_cpu_lim){
            $time_expired = 1;
            last;
          }
        }

        if ($time_expired){
          last;
        }
      }

      if ($time_expired){
        last;
      }
    }
    #print "sol_improved: $sol_improved \n";
  }
  
  print "[INFO] Last accuracy: $best_acc Last total number of non-zero digits: $best_cost \n";
  if ($time_expired){
    print "[INFO] The CPU time limit for tuning weights and biases is expired! \n";
  }

  return ($best_cost, \@best_weight_mat);
}

sub determine_quantization_value{
  my ($layer_cnt, $layer_arr_ref, $weight_flt_mat_ref, $act_fun_arr_ref, $test_cnt, $test_in_mat_ref, $test_out_mat_ref) = @_;
  my @weight_flt_mat = @ {$weight_flt_mat_ref};

  print "[INFO] Determining quantization value for the constant weights and biases... \n";
  my $quan_val = 1;
  my @weight_mat = ();

  my $best_acc = 0;
  my $best_cost = 9**9**9;
  my @best_weight_mat = ();
  while (1){
    #Quantize
    for (my $i=2; $i<=$layer_cnt; $i++){
      my $pi_cnt = ${$layer_arr_ref}[$i-1];
      my $po_cnt = ${$layer_arr_ref}[$i];
      foreach my $j (1 .. $po_cnt){
        foreach my $k (1 .. $pi_cnt+1){
          $weight_mat[$i-1][$j][$k] = POSIX::ceil((2**$quan_val)*$weight_flt_mat[$i-1][$j][$k]);
        }
      }
    }

    #@weight_mat = @{\@weight_flt_mat -> multiply_scalar(1)};

    #Find Accuracy
    my ($nzd_cost, $neuron_width_mat_ref) = compute_neurons_width($layer_cnt, $layer_arr_ref, \@weight_mat, $act_fun_arr_ref);
    my ($cls_acc, $the_acc) = compute_accuracy($layer_cnt, $layer_arr_ref, \@weight_mat, $act_fun_arr_ref, $neuron_width_mat_ref, $test_cnt, $test_in_mat_ref, $test_out_mat_ref);

    if ($the_acc > 0.5){
      if ($the_acc > $best_acc*1.001){
        $best_acc = $the_acc;
        $best_cost = $nzd_cost;
        @best_weight_mat = @ {dclone(\@weight_mat)};

        print "[INFO] Hurray!!! A better solution with $best_acc accuracy is obtained when the quantization value is $quan_val! \n";
        $quan_val++;
      }
      else{
        last;
      }
    }
    else{
      $quan_val++;
    }
  }

  return (\@best_weight_mat);
}

sub file_write_summary{
  my ($file_summary, $hard_acc, $hard_cost, $say_add, $pre_cpu_time, $last_time) = @_;

  open (my $the_fid, '>', $file_summary);

  if ($the_test == 1 and $acc_tech){
    printf $the_fid "* Hardware accuracy: %0f \n", $hard_acc;
  }
  printf $the_fid "* Hardware cost: %0f \n", $hard_cost;
  if ($the_tech > 1){
    printf $the_fid "* Total number of additions: %0d \n", $say_add;
  }
  if ($the_pre){
    printf $the_fid "* Pre-processing CPU time: %0f \n", $pre_cpu_time;
  }
  printf $the_fid "* Total CPU time: %0f \n", $last_time;

  close ($the_fid);
}

sub print_array_contents{
  my ($the_title, $the_cnt, @the_arr) = @_;

  print "$the_title: ";
  foreach my $i (1 .. $the_cnt){
    print "$the_arr[$i] ";
  }
  print "\n";
}

sub print_matrix_contents{
  my ($the_title, $the_row, $the_col, @the_mat) = @_;

  print "$the_title: \n";
  foreach my $i (1 .. $the_row){
    foreach my $j (1 .. $the_col){
      print "$the_mat[$i][$j] ";
    }
    print "\n";
  }
}

sub main_part{
  if (-e $file_weight){
    my $initial_time = time();

    my $say_add = 0;
    my $pre_acc = 0;
    my $pre_cost = 0;
    my $hard_acc = 0;
    my $last_time = 0;
    my $pre_cpu_time = 0;
    my $ver_file_cnt = 0;
    my @ver_file_arr = ();
    
    #Read the weights
    my ($layer_cnt, $hard_cost, $layer_arr_ref, $weight_mat_ref, $weight_flt_mat_ref) = file_read_weights();

    #Generate the activation function default values on hidden and output layers
    if ($act_fun_cnt == 1){
      foreach my $i (1 .. $layer_cnt-1){
        $act_fun_cnt++;
        $act_fun_arr[$act_fun_cnt] = "satlins";
      }
      $act_fun_arr[$layer_cnt] = "lin";
    }

    if ($act_fun_cnt == $layer_cnt){
      #Pre-processing
      if ($the_pre){
        my $pre_cpu_init = time();
        my ($val_cnt, $val_in_mat_ref, $val_out_mat_ref) = file_read_validation_data($layer_cnt, $layer_arr_ref);

        ($weight_mat_ref) = determine_quantization_value($layer_cnt, $layer_arr_ref, $weight_flt_mat_ref, \@act_fun_arr, $val_cnt, $val_in_mat_ref, $val_out_mat_ref);
        ($hard_cost, $weight_mat_ref) = tune_weights($layer_cnt, $layer_arr_ref, $weight_mat_ref, \@act_fun_arr, $val_cnt, $val_in_mat_ref, $val_out_mat_ref);
        $pre_cpu_time = time() - $pre_cpu_init;
      }

      #Generate the file names
      my $file_name = '';
      my $file_path = '';
      my $file_summary = '';
      my $file_verilog = '';
      my $path_index = length($file_weight);
      while ($path_index > -1){
        if (substr($file_weight, $path_index, 1) eq "/" or substr($file_weight, $path_index, 1) eq "\\"){
          last;
        }
        $path_index--;
      }

      if ($path_index > -1){
        $file_path = substr($file_weight, 0, $path_index+1);
      }
      $path_index++;

      my $dot_index = index($file_weight, ".", $path_index);
      if ($dot_index != -1){
        $dot_index--;
      }
      else{
        $dot_index = length($file_weight);
      }
      $file_name = substr($file_weight, $path_index, $dot_index-$path_index+1);
      $file_name .= "_i" . $in_width . "_o" . $out_width . "_q" . $quan_bit;

      if ($the_pre){
        $file_name .= "_pre";
      }
      if ($the_tech == 0){
        $file_name .= "_iw_act";
      }
      elsif ($the_tech == 1){
        $file_name .= "_cw_act";
      }
      elsif ($the_tech == 2){
        $file_name .= "_mcm_" . $the_aim . "_act";
      }
      if ($the_tech == 3){
        $file_name .= "_cavm_" . $the_aim . "_act";
      }
      elsif ($the_tech == 4){
        $file_name .= "_cmvm_" . $the_rep . "_" . $the_aim . "_act";
      }

      for (my $i=2; $i<=$act_fun_cnt; $i++){
        if ($act_fun_arr[$i] eq "lin"){
          $file_name .= "0";
        }
        elsif ($act_fun_arr[$i] eq "relu"){
          $file_name .= "1";
        }
        elsif ($act_fun_arr[$i] eq "satlin"){
          $file_name .= "2";
        }
        elsif ($act_fun_arr[$i] eq "satlins"){
          $file_name .= "3";
        }
      }
      #print "file_name: $file_name \n";
      #sleep 1;

      $file_verilog = $file_path . $file_name . ".v";
      $file_summary = $file_path . $file_name . ".summary";
      
      $ver_file_cnt++;
      $ver_file_arr[$ver_file_cnt] = $file_name . ".v";
      my $ver_file_arr_ref = \@ver_file_arr;

      #Generate the Verilog design files and the test bench
      my $muladd_width_mat_ref;
      my $neuron_width_mat_ref;

      if ($the_tech == 0){
        generate_verilog_code_weight_input($file_path, $file_name, $file_verilog, $layer_cnt, $layer_arr_ref, \@act_fun_arr);
      }
      elsif ($the_tech == 1){
        ($neuron_width_mat_ref) = generate_verilog_code_weight_constant($file_path, $file_name, $file_verilog, $layer_cnt, $layer_arr_ref, $weight_mat_ref, \@act_fun_arr);
        ($hard_acc) = generate_testbench($file_path, $file_name, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $weight_flt_mat_ref, $neuron_width_mat_ref, \@act_fun_arr);
      }
      elsif ($the_tech == 2){
        my ($paths_ok, $path_algo, $path_high2low) = extract_paths("paths.pl");
        ($ver_file_cnt, $ver_file_arr_ref, $muladd_width_mat_ref, $neuron_width_mat_ref) = generate_verilog_code_shift_adds($file_path, $file_name, $file_verilog, $ver_file_cnt, $ver_file_arr_ref, $layer_cnt, $layer_arr_ref, $weight_mat_ref, \@act_fun_arr);
        ($say_add, $ver_file_cnt, $ver_file_arr_ref) = generate_verilog_code_layer_mcm($file_path, $file_name, $path_algo, $path_high2low, $say_add, $ver_file_cnt, $ver_file_arr_ref, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $muladd_width_mat_ref);
        ($hard_acc) = generate_testbench($file_path, $file_name, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $weight_flt_mat_ref, $neuron_width_mat_ref, \@act_fun_arr);
      }
      elsif ($the_tech == 3){
        my ($paths_ok, $path_algo, $path_high2low) = extract_paths("paths.pl");
        ($ver_file_cnt, $ver_file_arr_ref, $muladd_width_mat_ref, $neuron_width_mat_ref) = generate_verilog_code_shift_adds($file_path, $file_name, $file_verilog, $ver_file_cnt, $ver_file_arr_ref, $layer_cnt, $layer_arr_ref, $weight_mat_ref, \@act_fun_arr);
        ($say_add, $ver_file_cnt, $ver_file_arr_ref) = generate_verilog_code_layer_cavm($file_path, $file_name, $path_algo, $path_high2low, $say_add, $ver_file_cnt, $ver_file_arr_ref, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $muladd_width_mat_ref);
        ($hard_acc) = generate_testbench($file_path, $file_name, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $weight_flt_mat_ref, $neuron_width_mat_ref, \@act_fun_arr);
      }
      elsif ($the_tech == 4){
        my ($paths_ok, $path_algo, $path_high2low) = extract_paths("paths.pl");
        ($ver_file_cnt, $ver_file_arr_ref, $muladd_width_mat_ref, $neuron_width_mat_ref) = generate_verilog_code_shift_adds($file_path, $file_name, $file_verilog, $ver_file_cnt, $ver_file_arr_ref, $layer_cnt, $layer_arr_ref, $weight_mat_ref, \@act_fun_arr);
        ($say_add) = generate_verilog_code_layer_cmvm($file_path, $file_name, $path_algo, $path_high2low, $say_add, $layer_cnt, $layer_arr_ref, $weight_mat_ref);
        ($hard_acc) = generate_testbench($file_path, $file_name, $layer_cnt, $layer_arr_ref, $weight_mat_ref, $weight_flt_mat_ref, $neuron_width_mat_ref, \@act_fun_arr);
      }

      #Generate the Cadence synthesis script
      generate_synth_script($file_path, $file_name, $layer_cnt, $ver_file_cnt, $ver_file_arr_ref);

      $last_time = time() - $initial_time;
      print "\n";
      if ($the_test == 1 and $acc_tech){
        print "[INFO] Hardware accuracy: $hard_acc \n";
      }
      print "[INFO] Hardware cost: $hard_cost \n";
      if ($the_tech > 1){
        print "[INFO] Total number of additions: $say_add \n";
      }
      if ($the_pre){
        print "[INFO] Pre-processing CPU time: $pre_cpu_time \n";
      }
      print "[INFO] Total CPU time: $last_time \n";

      file_write_summary($file_summary, $hard_acc, $hard_cost, $say_add, $pre_cpu_time, $last_time);
    }
    else{
      print "[ERROR] Activation function for each hidden layer and the output layer is NOT defined properly! \n";
    }
  }
  else{
    print "[ERROR] The $file_weight file does NOT exist! \n";
  }
}

