// Verilog Description of the Shift-Adds Design of the CMVM Block under the Signed Input
// Total Number of Additions/Subtractions: 23 

module example_ann (x1, x2, x3, x4, x5, x6, x7, x8, x9, x10,x11,x12,x13,x14,x15,x16,y1);

input signed [7:0] x1;
input signed [7:0] x2;
input signed [7:0] x3;
input signed [7:0] x4;
input signed [7:0] x5;
input signed [7:0] x6;
input signed [7:0] x7;
input signed [7:0] x8;
input signed [7:0] x9;
input signed [7:0] x10;
input signed [7:0] x11;
input signed [7:0] x12;
input signed [7:0] x13;
input signed [7:0] x14;
input signed [7:0] x15;
input signed [7:0] x16;
output signed [18:0] y1;

wire signed [9:0] s1;
wire signed [9:0] s2;
wire signed [9:0] s3;
wire signed [11:0] s4;
wire signed [12:0] s5;
wire signed [10:0] s6;
wire signed [9:0] s7;
wire signed [9:0] s8;
wire signed [9:0] s9;
wire signed [9:0] s10;
wire signed [9:0] s11;
wire signed [13:0] s12;
wire signed [10:0] s13;
wire signed [11:0] s14;
wire signed [11:0] s15;
wire signed [12:0] s16;
wire signed [12:0] s17;
wire signed [13:0] s18;
wire signed [12:0] s19;
wire signed [14:0] s20;
wire signed [14:0] s21;
wire signed [15:0] s22;
wire signed [16:0] s23;

//s1 = +2x2 -1x3 = x2<<1 - x3<<0

assign s1=((x2<<<1) - (x3));

//s2 = +1x4 -2x12 = x4<<0 - x12<<1

assign s2=((x4) - (x12<<<1));

//s3 = +1x6 +2x8 = x8<<1 + x6<<0

assign s3=((x8<<<1) + (x6));

//s4 = +8x5 +1x16 = x5<<3 + x16<<0

assign s4=((x5<<<3) + (x16));

//s5 = +8x2 -4x3 +8x5 +1x16 = s4<<0 + s1<<2

assign s5=((s4) + (s1<<<2));

//s6 = +1x6 +2x8 +4x9 = s3<<0 + x9<<2

assign s6=((s3) + (x9<<<2));

//s7 = -1x1 +1x5 = x5<<0 - x1<<0

assign s7=((x5) - (x1));

//s8 = -1x9 +1x10 = x10<<0 - x9<<0

assign s8=((x10) - (x9));

//s9 = +2x11 +1x14 = x11<<1 + x14<<0

assign s9=((x11<<<1) + (x14));

//s10 = +2x13 +1x15 = x13<<1 + x15<<0

assign s10=((x13<<<1) + (x15));

//s11 = +2x1 -1x7 = x1<<1 - x7<<0

assign s11=((x1<<<1) - (x7));

//s12 = -1x9 -31x10 = s8<<0 - x10<<5

assign s12=((s8) - (x10<<<5));

//s13 = -1x1 +2x2 -1x3 +1x5 = s1<<0 + s7<<0

assign s13=((s1) + (s7));

//s14 = +2x11 +4x13 +1x14 +2x15 = s10<<1 + s9<<0

assign s14=((s10<<<1) + (s9));

//s15 = +4x1 +1x4 -2x7 -2x12 = s11<<1 + s2<<0

assign s15=((s11<<<1) + (s2));

//s16 = +8x4 -1x6 -2x8 -4x9 -16x12 = s2<<3 - s6<<0

assign s16=((s2<<<3) - (s6));

//s17 = -1x1 -6x2 +3x3 -7x5 -1x16 = s13<<0 - s5<<0

assign s17=((s13) - (s5));

//s18 = -1x9 -31x10 -4x11 -8x13 -2x14 -4x15 = s12<<0 - s14<<1

assign s18=((s12) - (s14<<<1));

//s19 = +4x1 +1x4 +2x6 -2x7 +4x8 +8x9 -2x12 = s6<<1 + s15<<0

assign s19=((s6<<<1) + (s15));

//s20 = -32x2 +16x3 +8x4 -32x5 -1x6 -2x8 -4x9 -16x12 -4x16 = s16<<0 - s5<<2

assign s20=((s16) - (s5<<<2));

//s21 = -1x1 -6x2 +3x3 -7x5 -1x9 -31x10 -4x11 -8x13 -2x14 -4x15 -1x16 = s18<<0 + s17<<0

assign s21=((s18) + (s17));

//s22 = +16x1 -32x2 +16x3 +12x4 -32x5 +7x6 -8x7 +14x8 +28x9 -24x12 -4x16 = s20<<0 + s19<<2

assign s22=((s20) + (s19<<<2));

//s23 = +15x1 -38x2 +19x3 +12x4 -39x5 +7x6 -8x7 +14x8 +27x9 -31x10 -4x11 -24x12 -8x13 -2x14 -4x15 -5x16 = s22<<0 + s21<<0

assign s23=((s22) + (s21));

assign y1 = s23<<<2;

endmodule
