clear;

file_matrix=input('Enter the filename where the matrix coefficients exist: ','s');
rep_select=input('Choose the type of number representation (0:binary, 1:CSD): ');
target_areadelay=input('Optimization target at final subexpressions (0: Area 1: Delay): ');

%target_areadelay=0;
initial_cpu=cputime;

dot_point=0;
file_name=file_matrix;
for i=length(file_matrix):-1:1
    if file_name(1,i)=='.'
        dot_point=i;
        break
    end
end
if dot_point
    file_name=file_name(1:1,1:dot_point-1);
end

if rep_select
    file_result=[file_name,'_csd.result'];
else
    file_result=[file_name,'_binary.result'];
end

fid_result=fopen(file_result,'w');

[say_column,the_bitwidth,say_output,output_list,say_target,target_list,target_cost]=file_read_matrix(fid_result,file_matrix,rep_select);
[the_say_diff,the_diff_list,say_target,target_list,target_cost]=find_optimal_difference(rep_select,say_column,the_bitwidth,say_target,target_list,target_cost);

if say_target
    min_sol=inf;
    [say_cell,say_diff,diff_cell,say_target,target_cell]=find_differences(rep_select,say_column,the_bitwidth,say_output,output_list,the_say_diff,the_diff_list,say_target,target_list,target_cost);
    
    for i=1:say_cell
        if ~say_target(i,1)
            if say_diff(i,1)<min_sol
                min_sol=say_diff;
                
                the_say_partial=say_column;
                the_partial_list=eye(say_column);
                the_partial_imp=zeros(say_column,4);
                
                the_say_diff=say_diff(i,1);
                the_diff_list=diff_cell{i,1};
            end
        else
            [target_stats,target_repcell]=determine_representation(rep_select,say_column,say_target(i,1),target_cell{i,1});
            [say_partial,partial_list,partial_imp]=maxo_minc(rep_select,target_areadelay,say_column,say_target(i,1),target_cell{i,1},target_stats,target_repcell);

            if say_partial+say_diff(i,1)-say_column<min_sol
                min_sol=say_partial+say_diff(i,1)-say_column;
                
                the_say_partial=say_partial;
                the_partial_list=partial_list;
                the_partial_imp=partial_imp;
                
                the_say_diff=say_diff(i,1);
                the_diff_list=diff_cell{i,1};
            end
        end
    end
else
    the_say_partial=say_column;
    the_partial_list=eye(say_column);
    the_partial_imp=zeros(say_column,4);
end

if the_say_diff
    [say_partial,partial_list,partial_imp]=find_diff_implementations(say_column,the_bitwidth,the_say_diff,the_diff_list,the_say_partial,the_partial_list,the_partial_imp);
else
    say_partial=the_say_partial;
    partial_list=the_partial_list;
    partial_imp=the_partial_imp;
end

fprintf(fid_result,'\n');
fprintf(fid_result,'*** Implementation of Expressions ***\n');
fprintf(fid_result,'\n');

max_level=0;
say_subexp=0;
subexp_list=zeros(say_partial,1);
level_partials=zeros(say_partial,1);

for i=say_column+1:say_partial
    output_pos=whereis_inside_array(partial_list(i,:),say_column,say_output,output_list);
    
    if output_pos
        subexp_list(i,1)=(-1)*output_pos;
        fprintf(fid_result,'O%d: ',output_pos);
    else
        say_subexp=say_subexp+1;
        subexp_list(i,1)=say_subexp;
        fprintf(fid_result,'S%d: ',say_subexp);
    end
    
    file_write_inputterms(fid_result,say_column,partial_list(i,:))
    
    if partial_imp(i,1)<0
        fprintf(fid_result,' = -');
    else
        fprintf(fid_result,' = +');
    end
    
    if subexp_list(partial_imp(i,2),1)<0
        fprintf(fid_result,'O%d<<%d ',abs(subexp_list(partial_imp(i,2),1)),log2(abs(partial_imp(i,1))));
    elseif subexp_list(partial_imp(i,2),1)>0
        fprintf(fid_result,'S%d<<%d ',abs(subexp_list(partial_imp(i,2),1)),log2(abs(partial_imp(i,1))));
    else
        fprintf(fid_result,'X%d<<%d ',partial_imp(i,2),log2(abs(partial_imp(i,1))));
    end
    
    if partial_imp(i,3)<0
        fprintf(fid_result,'-');
    else
        fprintf(fid_result,'+');
    end
    
    if subexp_list(partial_imp(i,4),1)<0
        fprintf(fid_result,'O%d<<%d\n',abs(subexp_list(partial_imp(i,4),1)),log2(abs(partial_imp(i,3))));
    elseif subexp_list(partial_imp(i,4),1)>0
        fprintf(fid_result,'S%d<<%d\n',abs(subexp_list(partial_imp(i,4),1)),log2(abs(partial_imp(i,3))));
    else
        fprintf(fid_result,'X%d<<%d\n',partial_imp(i,4),log2(abs(partial_imp(i,3))));
    end
    
    level_partials(i,1)=max(level_partials(partial_imp(i,2),1),level_partials(partial_imp(i,4),1))+1;
    
    if level_partials(i,1)>max_level
        max_level=level_partials(i,1);
    end
end

last_cpu=cputime-initial_cpu;

fprintf(fid_result,'\n');
fprintf(fid_result,'* Number of operations: %d\n',say_partial-say_column);
fprintf(fid_result,'* Number of adder-steps: %d\n',max_level);
fprintf(fid_result,'* CPU time: %.1f\n',last_cpu);
fprintf(fid_result,'\n');

fclose(fid_result);

fprintf('\n');
fprintf('* Number of operations: %d\n',say_partial-say_column);
fprintf('* Number of adder-steps: %d\n',max_level);
fprintf('* CPU time: %.1f\n',last_cpu);
fprintf('\n');
