// Verilog Description of the Shift-Adds Design of the CMVM Block under the Signed Input
// Total Number of Additions/Subtractions: 4 

module example (x1,x2,x3,y1);

input signed [7:0] x1;
input signed [7:0] x2;
input signed [7:0] x3;
output signed [14:0] y1;

wire signed [9:0] s1;
wire signed [8:0] s2;
wire signed [12:0] s3;
wire signed [14:0] s4;

//s1 = +1x1 +2x2 = x2<<1 + x1<<0

assign s1=((x2<<<1) + (x1));

//s2 = -1x1 +1x2 = x2<<0 - x1<<0

assign s2=((x2) - (x1));

//s3 = +7x1 +17x2 = s1<<3 + s2<<0

assign s3=((s1<<<3) + (s2));

//s4 = +23x1 +49x2 = s3<<0 + s1<<4

assign s4=((s3) + (s1<<<4));

assign y1 = s4;

endmodule
